=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
Generator version: 7.10.0

=end

require 'cgi'

module PulpRpmClient
  class AcsRpmApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Add a role
    # Add a role for this object to users/groups.
    # @param rpm_rpm_alternate_content_source_href [String] 
    # @param nested_role [NestedRole] 
    # @param [Hash] opts the optional parameters
    # @return [NestedRoleResponse]
    def add_role(rpm_rpm_alternate_content_source_href, nested_role, opts = {})
      data, _status_code, _headers = add_role_with_http_info(rpm_rpm_alternate_content_source_href, nested_role, opts)
      data
    end

    # Add a role
    # Add a role for this object to users/groups.
    # @param rpm_rpm_alternate_content_source_href [String] 
    # @param nested_role [NestedRole] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(NestedRoleResponse, Integer, Hash)>] NestedRoleResponse data, response status code and response headers
    def add_role_with_http_info(rpm_rpm_alternate_content_source_href, nested_role, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AcsRpmApi.add_role ...'
      end
      # verify the required parameter 'rpm_rpm_alternate_content_source_href' is set
      if @api_client.config.client_side_validation && rpm_rpm_alternate_content_source_href.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_rpm_alternate_content_source_href' when calling AcsRpmApi.add_role"
      end
      # verify the required parameter 'nested_role' is set
      if @api_client.config.client_side_validation && nested_role.nil?
        fail ArgumentError, "Missing the required parameter 'nested_role' when calling AcsRpmApi.add_role"
      end
      # resource path
      local_var_path = '{rpm_rpm_alternate_content_source_href}add_role/'.sub('{' + 'rpm_rpm_alternate_content_source_href' + '}', CGI.escape(rpm_rpm_alternate_content_source_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']
      # HTTP header 'Content-Type'
      content_type = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])
      if !content_type.nil?
          header_params['Content-Type'] = content_type
      end

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(nested_role)

      # return_type
      return_type = opts[:debug_return_type] || 'NestedRoleResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"AcsRpmApi.add_role",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AcsRpmApi#add_role\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Create a rpm alternate content source
    # ViewSet for ACS.
    # @param rpm_rpm_alternate_content_source [RpmRpmAlternateContentSource] 
    # @param [Hash] opts the optional parameters
    # @return [RpmRpmAlternateContentSourceResponse]
    def create(rpm_rpm_alternate_content_source, opts = {})
      data, _status_code, _headers = create_with_http_info(rpm_rpm_alternate_content_source, opts)
      data
    end

    # Create a rpm alternate content source
    # ViewSet for ACS.
    # @param rpm_rpm_alternate_content_source [RpmRpmAlternateContentSource] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(RpmRpmAlternateContentSourceResponse, Integer, Hash)>] RpmRpmAlternateContentSourceResponse data, response status code and response headers
    def create_with_http_info(rpm_rpm_alternate_content_source, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AcsRpmApi.create ...'
      end
      # verify the required parameter 'rpm_rpm_alternate_content_source' is set
      if @api_client.config.client_side_validation && rpm_rpm_alternate_content_source.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_rpm_alternate_content_source' when calling AcsRpmApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/acs/rpm/rpm/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']
      # HTTP header 'Content-Type'
      content_type = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])
      if !content_type.nil?
          header_params['Content-Type'] = content_type
      end

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(rpm_rpm_alternate_content_source)

      # return_type
      return_type = opts[:debug_return_type] || 'RpmRpmAlternateContentSourceResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"AcsRpmApi.create",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AcsRpmApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete a rpm alternate content source
    # Trigger an asynchronous delete ACS task
    # @param rpm_rpm_alternate_content_source_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def delete(rpm_rpm_alternate_content_source_href, opts = {})
      data, _status_code, _headers = delete_with_http_info(rpm_rpm_alternate_content_source_href, opts)
      data
    end

    # Delete a rpm alternate content source
    # Trigger an asynchronous delete ACS task
    # @param rpm_rpm_alternate_content_source_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def delete_with_http_info(rpm_rpm_alternate_content_source_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AcsRpmApi.delete ...'
      end
      # verify the required parameter 'rpm_rpm_alternate_content_source_href' is set
      if @api_client.config.client_side_validation && rpm_rpm_alternate_content_source_href.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_rpm_alternate_content_source_href' when calling AcsRpmApi.delete"
      end
      # resource path
      local_var_path = '{rpm_rpm_alternate_content_source_href}'.sub('{' + 'rpm_rpm_alternate_content_source_href' + '}', CGI.escape(rpm_rpm_alternate_content_source_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'AsyncOperationResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"AcsRpmApi.delete",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AcsRpmApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List rpm alternate content sources
    # ViewSet for ACS.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name Filter results where name matches value
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [String] :name__icontains Filter results where name contains value
    # @option opts [String] :name__iexact Filter results where name matches value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__iregex Filter results where name matches regex value
    # @option opts [String] :name__istartswith Filter results where name starts with value
    # @option opts [String] :name__regex Filter results where name matches regex value
    # @option opts [String] :name__startswith Filter results where name starts with value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering  * &#x60;pulp_id&#x60; - Pulp id * &#x60;-pulp_id&#x60; - Pulp id (descending) * &#x60;pulp_created&#x60; - Pulp created * &#x60;-pulp_created&#x60; - Pulp created (descending) * &#x60;pulp_last_updated&#x60; - Pulp last updated * &#x60;-pulp_last_updated&#x60; - Pulp last updated (descending) * &#x60;pulp_type&#x60; - Pulp type * &#x60;-pulp_type&#x60; - Pulp type (descending) * &#x60;name&#x60; - Name * &#x60;-name&#x60; - Name (descending) * &#x60;last_refreshed&#x60; - Last refreshed * &#x60;-last_refreshed&#x60; - Last refreshed (descending) * &#x60;pk&#x60; - Pk * &#x60;-pk&#x60; - Pk (descending)
    # @option opts [Array<String>] :prn__in Multiple values may be separated by commas.
    # @option opts [Array<String>] :pulp_href__in Multiple values may be separated by commas.
    # @option opts [Array<String>] :pulp_id__in Multiple values may be separated by commas.
    # @option opts [String] :q Filter results by using NOT, AND and OR operations on other filters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedrpmRpmAlternateContentSourceResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List rpm alternate content sources
    # ViewSet for ACS.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name Filter results where name matches value
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [String] :name__icontains Filter results where name contains value
    # @option opts [String] :name__iexact Filter results where name matches value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__iregex Filter results where name matches regex value
    # @option opts [String] :name__istartswith Filter results where name starts with value
    # @option opts [String] :name__regex Filter results where name matches regex value
    # @option opts [String] :name__startswith Filter results where name starts with value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering  * &#x60;pulp_id&#x60; - Pulp id * &#x60;-pulp_id&#x60; - Pulp id (descending) * &#x60;pulp_created&#x60; - Pulp created * &#x60;-pulp_created&#x60; - Pulp created (descending) * &#x60;pulp_last_updated&#x60; - Pulp last updated * &#x60;-pulp_last_updated&#x60; - Pulp last updated (descending) * &#x60;pulp_type&#x60; - Pulp type * &#x60;-pulp_type&#x60; - Pulp type (descending) * &#x60;name&#x60; - Name * &#x60;-name&#x60; - Name (descending) * &#x60;last_refreshed&#x60; - Last refreshed * &#x60;-last_refreshed&#x60; - Last refreshed (descending) * &#x60;pk&#x60; - Pk * &#x60;-pk&#x60; - Pk (descending)
    # @option opts [Array<String>] :prn__in Multiple values may be separated by commas.
    # @option opts [Array<String>] :pulp_href__in Multiple values may be separated by commas.
    # @option opts [Array<String>] :pulp_id__in Multiple values may be separated by commas.
    # @option opts [String] :q Filter results by using NOT, AND and OR operations on other filters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedrpmRpmAlternateContentSourceResponseList, Integer, Hash)>] PaginatedrpmRpmAlternateContentSourceResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AcsRpmApi.list ...'
      end
      allowable_values = ["-last_refreshed", "-name", "-pk", "-pulp_created", "-pulp_id", "-pulp_last_updated", "-pulp_type", "last_refreshed", "name", "pk", "pulp_created", "pulp_id", "pulp_last_updated", "pulp_type"]
      if @api_client.config.client_side_validation && opts[:'ordering'] && !opts[:'ordering'].all? { |item| allowable_values.include?(item) }
        fail ArgumentError, "invalid value for \"ordering\", must include one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/pulp/api/v3/acs/rpm/rpm/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'name__contains'] = opts[:'name__contains'] if !opts[:'name__contains'].nil?
      query_params[:'name__icontains'] = opts[:'name__icontains'] if !opts[:'name__icontains'].nil?
      query_params[:'name__iexact'] = opts[:'name__iexact'] if !opts[:'name__iexact'].nil?
      query_params[:'name__in'] = @api_client.build_collection_param(opts[:'name__in'], :csv) if !opts[:'name__in'].nil?
      query_params[:'name__iregex'] = opts[:'name__iregex'] if !opts[:'name__iregex'].nil?
      query_params[:'name__istartswith'] = opts[:'name__istartswith'] if !opts[:'name__istartswith'].nil?
      query_params[:'name__regex'] = opts[:'name__regex'] if !opts[:'name__regex'].nil?
      query_params[:'name__startswith'] = opts[:'name__startswith'] if !opts[:'name__startswith'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = @api_client.build_collection_param(opts[:'ordering'], :csv) if !opts[:'ordering'].nil?
      query_params[:'prn__in'] = @api_client.build_collection_param(opts[:'prn__in'], :csv) if !opts[:'prn__in'].nil?
      query_params[:'pulp_href__in'] = @api_client.build_collection_param(opts[:'pulp_href__in'], :csv) if !opts[:'pulp_href__in'].nil?
      query_params[:'pulp_id__in'] = @api_client.build_collection_param(opts[:'pulp_id__in'], :csv) if !opts[:'pulp_id__in'].nil?
      query_params[:'q'] = opts[:'q'] if !opts[:'q'].nil?
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'PaginatedrpmRpmAlternateContentSourceResponseList'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"AcsRpmApi.list",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AcsRpmApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List roles
    # List roles assigned to this object.
    # @param rpm_rpm_alternate_content_source_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [ObjectRolesResponse]
    def list_roles(rpm_rpm_alternate_content_source_href, opts = {})
      data, _status_code, _headers = list_roles_with_http_info(rpm_rpm_alternate_content_source_href, opts)
      data
    end

    # List roles
    # List roles assigned to this object.
    # @param rpm_rpm_alternate_content_source_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(ObjectRolesResponse, Integer, Hash)>] ObjectRolesResponse data, response status code and response headers
    def list_roles_with_http_info(rpm_rpm_alternate_content_source_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AcsRpmApi.list_roles ...'
      end
      # verify the required parameter 'rpm_rpm_alternate_content_source_href' is set
      if @api_client.config.client_side_validation && rpm_rpm_alternate_content_source_href.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_rpm_alternate_content_source_href' when calling AcsRpmApi.list_roles"
      end
      # resource path
      local_var_path = '{rpm_rpm_alternate_content_source_href}list_roles/'.sub('{' + 'rpm_rpm_alternate_content_source_href' + '}', CGI.escape(rpm_rpm_alternate_content_source_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'ObjectRolesResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"AcsRpmApi.list_roles",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AcsRpmApi#list_roles\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List user permissions
    # List permissions available to the current user on this object.
    # @param rpm_rpm_alternate_content_source_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [MyPermissionsResponse]
    def my_permissions(rpm_rpm_alternate_content_source_href, opts = {})
      data, _status_code, _headers = my_permissions_with_http_info(rpm_rpm_alternate_content_source_href, opts)
      data
    end

    # List user permissions
    # List permissions available to the current user on this object.
    # @param rpm_rpm_alternate_content_source_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(MyPermissionsResponse, Integer, Hash)>] MyPermissionsResponse data, response status code and response headers
    def my_permissions_with_http_info(rpm_rpm_alternate_content_source_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AcsRpmApi.my_permissions ...'
      end
      # verify the required parameter 'rpm_rpm_alternate_content_source_href' is set
      if @api_client.config.client_side_validation && rpm_rpm_alternate_content_source_href.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_rpm_alternate_content_source_href' when calling AcsRpmApi.my_permissions"
      end
      # resource path
      local_var_path = '{rpm_rpm_alternate_content_source_href}my_permissions/'.sub('{' + 'rpm_rpm_alternate_content_source_href' + '}', CGI.escape(rpm_rpm_alternate_content_source_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'MyPermissionsResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"AcsRpmApi.my_permissions",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AcsRpmApi#my_permissions\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a rpm alternate content source
    # Trigger an asynchronous partial update task
    # @param rpm_rpm_alternate_content_source_href [String] 
    # @param patchedrpm_rpm_alternate_content_source [PatchedrpmRpmAlternateContentSource] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def partial_update(rpm_rpm_alternate_content_source_href, patchedrpm_rpm_alternate_content_source, opts = {})
      data, _status_code, _headers = partial_update_with_http_info(rpm_rpm_alternate_content_source_href, patchedrpm_rpm_alternate_content_source, opts)
      data
    end

    # Update a rpm alternate content source
    # Trigger an asynchronous partial update task
    # @param rpm_rpm_alternate_content_source_href [String] 
    # @param patchedrpm_rpm_alternate_content_source [PatchedrpmRpmAlternateContentSource] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def partial_update_with_http_info(rpm_rpm_alternate_content_source_href, patchedrpm_rpm_alternate_content_source, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AcsRpmApi.partial_update ...'
      end
      # verify the required parameter 'rpm_rpm_alternate_content_source_href' is set
      if @api_client.config.client_side_validation && rpm_rpm_alternate_content_source_href.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_rpm_alternate_content_source_href' when calling AcsRpmApi.partial_update"
      end
      # verify the required parameter 'patchedrpm_rpm_alternate_content_source' is set
      if @api_client.config.client_side_validation && patchedrpm_rpm_alternate_content_source.nil?
        fail ArgumentError, "Missing the required parameter 'patchedrpm_rpm_alternate_content_source' when calling AcsRpmApi.partial_update"
      end
      # resource path
      local_var_path = '{rpm_rpm_alternate_content_source_href}'.sub('{' + 'rpm_rpm_alternate_content_source_href' + '}', CGI.escape(rpm_rpm_alternate_content_source_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']
      # HTTP header 'Content-Type'
      content_type = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])
      if !content_type.nil?
          header_params['Content-Type'] = content_type
      end

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(patchedrpm_rpm_alternate_content_source)

      # return_type
      return_type = opts[:debug_return_type] || 'AsyncOperationResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"AcsRpmApi.partial_update",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AcsRpmApi#partial_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a rpm alternate content source
    # ViewSet for ACS.
    # @param rpm_rpm_alternate_content_source_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [RpmRpmAlternateContentSourceResponse]
    def read(rpm_rpm_alternate_content_source_href, opts = {})
      data, _status_code, _headers = read_with_http_info(rpm_rpm_alternate_content_source_href, opts)
      data
    end

    # Inspect a rpm alternate content source
    # ViewSet for ACS.
    # @param rpm_rpm_alternate_content_source_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(RpmRpmAlternateContentSourceResponse, Integer, Hash)>] RpmRpmAlternateContentSourceResponse data, response status code and response headers
    def read_with_http_info(rpm_rpm_alternate_content_source_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AcsRpmApi.read ...'
      end
      # verify the required parameter 'rpm_rpm_alternate_content_source_href' is set
      if @api_client.config.client_side_validation && rpm_rpm_alternate_content_source_href.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_rpm_alternate_content_source_href' when calling AcsRpmApi.read"
      end
      # resource path
      local_var_path = '{rpm_rpm_alternate_content_source_href}'.sub('{' + 'rpm_rpm_alternate_content_source_href' + '}', CGI.escape(rpm_rpm_alternate_content_source_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'RpmRpmAlternateContentSourceResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"AcsRpmApi.read",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AcsRpmApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Trigger an asynchronous task to create Alternate Content Source content.
    # @param rpm_rpm_alternate_content_source_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [TaskGroupOperationResponse]
    def refresh(rpm_rpm_alternate_content_source_href, opts = {})
      data, _status_code, _headers = refresh_with_http_info(rpm_rpm_alternate_content_source_href, opts)
      data
    end

    # Trigger an asynchronous task to create Alternate Content Source content.
    # @param rpm_rpm_alternate_content_source_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(TaskGroupOperationResponse, Integer, Hash)>] TaskGroupOperationResponse data, response status code and response headers
    def refresh_with_http_info(rpm_rpm_alternate_content_source_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AcsRpmApi.refresh ...'
      end
      # verify the required parameter 'rpm_rpm_alternate_content_source_href' is set
      if @api_client.config.client_side_validation && rpm_rpm_alternate_content_source_href.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_rpm_alternate_content_source_href' when calling AcsRpmApi.refresh"
      end
      # resource path
      local_var_path = '{rpm_rpm_alternate_content_source_href}refresh/'.sub('{' + 'rpm_rpm_alternate_content_source_href' + '}', CGI.escape(rpm_rpm_alternate_content_source_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'TaskGroupOperationResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"AcsRpmApi.refresh",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AcsRpmApi#refresh\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Remove a role
    # Remove a role for this object from users/groups.
    # @param rpm_rpm_alternate_content_source_href [String] 
    # @param nested_role [NestedRole] 
    # @param [Hash] opts the optional parameters
    # @return [NestedRoleResponse]
    def remove_role(rpm_rpm_alternate_content_source_href, nested_role, opts = {})
      data, _status_code, _headers = remove_role_with_http_info(rpm_rpm_alternate_content_source_href, nested_role, opts)
      data
    end

    # Remove a role
    # Remove a role for this object from users/groups.
    # @param rpm_rpm_alternate_content_source_href [String] 
    # @param nested_role [NestedRole] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(NestedRoleResponse, Integer, Hash)>] NestedRoleResponse data, response status code and response headers
    def remove_role_with_http_info(rpm_rpm_alternate_content_source_href, nested_role, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AcsRpmApi.remove_role ...'
      end
      # verify the required parameter 'rpm_rpm_alternate_content_source_href' is set
      if @api_client.config.client_side_validation && rpm_rpm_alternate_content_source_href.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_rpm_alternate_content_source_href' when calling AcsRpmApi.remove_role"
      end
      # verify the required parameter 'nested_role' is set
      if @api_client.config.client_side_validation && nested_role.nil?
        fail ArgumentError, "Missing the required parameter 'nested_role' when calling AcsRpmApi.remove_role"
      end
      # resource path
      local_var_path = '{rpm_rpm_alternate_content_source_href}remove_role/'.sub('{' + 'rpm_rpm_alternate_content_source_href' + '}', CGI.escape(rpm_rpm_alternate_content_source_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']
      # HTTP header 'Content-Type'
      content_type = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])
      if !content_type.nil?
          header_params['Content-Type'] = content_type
      end

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(nested_role)

      # return_type
      return_type = opts[:debug_return_type] || 'NestedRoleResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"AcsRpmApi.remove_role",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AcsRpmApi#remove_role\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a rpm alternate content source
    # Trigger an asynchronous update task
    # @param rpm_rpm_alternate_content_source_href [String] 
    # @param rpm_rpm_alternate_content_source [RpmRpmAlternateContentSource] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def update(rpm_rpm_alternate_content_source_href, rpm_rpm_alternate_content_source, opts = {})
      data, _status_code, _headers = update_with_http_info(rpm_rpm_alternate_content_source_href, rpm_rpm_alternate_content_source, opts)
      data
    end

    # Update a rpm alternate content source
    # Trigger an asynchronous update task
    # @param rpm_rpm_alternate_content_source_href [String] 
    # @param rpm_rpm_alternate_content_source [RpmRpmAlternateContentSource] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def update_with_http_info(rpm_rpm_alternate_content_source_href, rpm_rpm_alternate_content_source, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AcsRpmApi.update ...'
      end
      # verify the required parameter 'rpm_rpm_alternate_content_source_href' is set
      if @api_client.config.client_side_validation && rpm_rpm_alternate_content_source_href.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_rpm_alternate_content_source_href' when calling AcsRpmApi.update"
      end
      # verify the required parameter 'rpm_rpm_alternate_content_source' is set
      if @api_client.config.client_side_validation && rpm_rpm_alternate_content_source.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_rpm_alternate_content_source' when calling AcsRpmApi.update"
      end
      # resource path
      local_var_path = '{rpm_rpm_alternate_content_source_href}'.sub('{' + 'rpm_rpm_alternate_content_source_href' + '}', CGI.escape(rpm_rpm_alternate_content_source_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']
      # HTTP header 'Content-Type'
      content_type = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])
      if !content_type.nil?
          header_params['Content-Type'] = content_type
      end

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(rpm_rpm_alternate_content_source)

      # return_type
      return_type = opts[:debug_return_type] || 'AsyncOperationResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"AcsRpmApi.update",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AcsRpmApi#update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
