=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
Generator version: 7.10.0

=end

require 'cgi'

module PulpRpmClient
  class ContentPackagecategoriesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # List package categorys
    # PackageCategory ViewSet.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering  * &#x60;pk&#x60; - Pk * &#x60;-pk&#x60; - Pk (descending)
    # @option opts [Float] :orphaned_for Minutes Content has been orphaned for. -1 uses ORPHAN_PROTECTION_TIME.
    # @option opts [Array<String>] :prn__in Multiple values may be separated by commas.
    # @option opts [Array<String>] :pulp_href__in Multiple values may be separated by commas.
    # @option opts [Array<String>] :pulp_id__in Multiple values may be separated by commas.
    # @option opts [String] :pulp_label_select Filter labels by search string
    # @option opts [String] :q Filter results by using NOT, AND and OR operations on other filters
    # @option opts [String] :repository_version Repository Version referenced by HREF/PRN
    # @option opts [String] :repository_version_added Repository Version referenced by HREF/PRN
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF/PRN
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedrpmPackageCategoryResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List package categorys
    # PackageCategory ViewSet.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering  * &#x60;pk&#x60; - Pk * &#x60;-pk&#x60; - Pk (descending)
    # @option opts [Float] :orphaned_for Minutes Content has been orphaned for. -1 uses ORPHAN_PROTECTION_TIME.
    # @option opts [Array<String>] :prn__in Multiple values may be separated by commas.
    # @option opts [Array<String>] :pulp_href__in Multiple values may be separated by commas.
    # @option opts [Array<String>] :pulp_id__in Multiple values may be separated by commas.
    # @option opts [String] :pulp_label_select Filter labels by search string
    # @option opts [String] :q Filter results by using NOT, AND and OR operations on other filters
    # @option opts [String] :repository_version Repository Version referenced by HREF/PRN
    # @option opts [String] :repository_version_added Repository Version referenced by HREF/PRN
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF/PRN
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedrpmPackageCategoryResponseList, Integer, Hash)>] PaginatedrpmPackageCategoryResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentPackagecategoriesApi.list ...'
      end
      allowable_values = ["-pk", "pk"]
      if @api_client.config.client_side_validation && opts[:'ordering'] && !opts[:'ordering'].all? { |item| allowable_values.include?(item) }
        fail ArgumentError, "invalid value for \"ordering\", must include one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/rpm/packagecategories/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = @api_client.build_collection_param(opts[:'ordering'], :csv) if !opts[:'ordering'].nil?
      query_params[:'orphaned_for'] = opts[:'orphaned_for'] if !opts[:'orphaned_for'].nil?
      query_params[:'prn__in'] = @api_client.build_collection_param(opts[:'prn__in'], :csv) if !opts[:'prn__in'].nil?
      query_params[:'pulp_href__in'] = @api_client.build_collection_param(opts[:'pulp_href__in'], :csv) if !opts[:'pulp_href__in'].nil?
      query_params[:'pulp_id__in'] = @api_client.build_collection_param(opts[:'pulp_id__in'], :csv) if !opts[:'pulp_id__in'].nil?
      query_params[:'pulp_label_select'] = opts[:'pulp_label_select'] if !opts[:'pulp_label_select'].nil?
      query_params[:'q'] = opts[:'q'] if !opts[:'q'].nil?
      query_params[:'repository_version'] = opts[:'repository_version'] if !opts[:'repository_version'].nil?
      query_params[:'repository_version_added'] = opts[:'repository_version_added'] if !opts[:'repository_version_added'].nil?
      query_params[:'repository_version_removed'] = opts[:'repository_version_removed'] if !opts[:'repository_version_removed'].nil?
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'PaginatedrpmPackageCategoryResponseList'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"ContentPackagecategoriesApi.list",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentPackagecategoriesApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a package category
    # PackageCategory ViewSet.
    # @param rpm_package_category_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [RpmPackageCategoryResponse]
    def read(rpm_package_category_href, opts = {})
      data, _status_code, _headers = read_with_http_info(rpm_package_category_href, opts)
      data
    end

    # Inspect a package category
    # PackageCategory ViewSet.
    # @param rpm_package_category_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(RpmPackageCategoryResponse, Integer, Hash)>] RpmPackageCategoryResponse data, response status code and response headers
    def read_with_http_info(rpm_package_category_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentPackagecategoriesApi.read ...'
      end
      # verify the required parameter 'rpm_package_category_href' is set
      if @api_client.config.client_side_validation && rpm_package_category_href.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_package_category_href' when calling ContentPackagecategoriesApi.read"
      end
      # resource path
      local_var_path = '{rpm_package_category_href}'.sub('{' + 'rpm_package_category_href' + '}', CGI.escape(rpm_package_category_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'RpmPackageCategoryResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"ContentPackagecategoriesApi.read",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentPackagecategoriesApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Set a label
    # Set a single pulp_label on the object to a specific value or null.
    # @param rpm_package_category_href [String] 
    # @param set_label [SetLabel] 
    # @param [Hash] opts the optional parameters
    # @return [SetLabelResponse]
    def set_label(rpm_package_category_href, set_label, opts = {})
      data, _status_code, _headers = set_label_with_http_info(rpm_package_category_href, set_label, opts)
      data
    end

    # Set a label
    # Set a single pulp_label on the object to a specific value or null.
    # @param rpm_package_category_href [String] 
    # @param set_label [SetLabel] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(SetLabelResponse, Integer, Hash)>] SetLabelResponse data, response status code and response headers
    def set_label_with_http_info(rpm_package_category_href, set_label, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentPackagecategoriesApi.set_label ...'
      end
      # verify the required parameter 'rpm_package_category_href' is set
      if @api_client.config.client_side_validation && rpm_package_category_href.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_package_category_href' when calling ContentPackagecategoriesApi.set_label"
      end
      # verify the required parameter 'set_label' is set
      if @api_client.config.client_side_validation && set_label.nil?
        fail ArgumentError, "Missing the required parameter 'set_label' when calling ContentPackagecategoriesApi.set_label"
      end
      # resource path
      local_var_path = '{rpm_package_category_href}set_label/'.sub('{' + 'rpm_package_category_href' + '}', CGI.escape(rpm_package_category_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']
      # HTTP header 'Content-Type'
      content_type = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])
      if !content_type.nil?
          header_params['Content-Type'] = content_type
      end

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(set_label)

      # return_type
      return_type = opts[:debug_return_type] || 'SetLabelResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"ContentPackagecategoriesApi.set_label",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentPackagecategoriesApi#set_label\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Unset a label
    # Unset a single pulp_label on the object.
    # @param rpm_package_category_href [String] 
    # @param unset_label [UnsetLabel] 
    # @param [Hash] opts the optional parameters
    # @return [UnsetLabelResponse]
    def unset_label(rpm_package_category_href, unset_label, opts = {})
      data, _status_code, _headers = unset_label_with_http_info(rpm_package_category_href, unset_label, opts)
      data
    end

    # Unset a label
    # Unset a single pulp_label on the object.
    # @param rpm_package_category_href [String] 
    # @param unset_label [UnsetLabel] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(UnsetLabelResponse, Integer, Hash)>] UnsetLabelResponse data, response status code and response headers
    def unset_label_with_http_info(rpm_package_category_href, unset_label, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentPackagecategoriesApi.unset_label ...'
      end
      # verify the required parameter 'rpm_package_category_href' is set
      if @api_client.config.client_side_validation && rpm_package_category_href.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_package_category_href' when calling ContentPackagecategoriesApi.unset_label"
      end
      # verify the required parameter 'unset_label' is set
      if @api_client.config.client_side_validation && unset_label.nil?
        fail ArgumentError, "Missing the required parameter 'unset_label' when calling ContentPackagecategoriesApi.unset_label"
      end
      # resource path
      local_var_path = '{rpm_package_category_href}unset_label/'.sub('{' + 'rpm_package_category_href' + '}', CGI.escape(rpm_package_category_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']
      # HTTP header 'Content-Type'
      content_type = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])
      if !content_type.nil?
          header_params['Content-Type'] = content_type
      end

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(unset_label)

      # return_type
      return_type = opts[:debug_return_type] || 'UnsetLabelResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"ContentPackagecategoriesApi.unset_label",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentPackagecategoriesApi#unset_label\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
