=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
Generator version: 7.10.0

=end

require 'cgi'

module PulpRpmClient
  class ContentPackagesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a package
    # Trigger an asynchronous task to create an RPM package,optionally create new repository version.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :repository A URI of a repository the new content unit should be associated with.
    # @option opts [Hash<String, String>] :pulp_labels A dictionary of arbitrary key/value pairs used to describe a specific Content instance.
    # @option opts [String] :artifact Artifact file representing the physical content
    # @option opts [String] :relative_path Path where the artifact is located relative to distributions base_path
    # @option opts [File] :file An uploaded file that may be turned into the content unit.
    # @option opts [String] :upload An uncommitted upload that may be turned into the content unit.
    # @option opts [String] :file_url A url that Pulp can download and turn into the content unit.
    # @return [AsyncOperationResponse]
    def create(opts = {})
      data, _status_code, _headers = create_with_http_info(opts)
      data
    end

    # Create a package
    # Trigger an asynchronous task to create an RPM package,optionally create new repository version.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :repository A URI of a repository the new content unit should be associated with.
    # @option opts [Hash<String, String>] :pulp_labels A dictionary of arbitrary key/value pairs used to describe a specific Content instance.
    # @option opts [String] :artifact Artifact file representing the physical content
    # @option opts [String] :relative_path Path where the artifact is located relative to distributions base_path
    # @option opts [File] :file An uploaded file that may be turned into the content unit.
    # @option opts [String] :upload An uncommitted upload that may be turned into the content unit.
    # @option opts [String] :file_url A url that Pulp can download and turn into the content unit.
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def create_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentPackagesApi.create ...'
      end
      if @api_client.config.client_side_validation && !opts[:'relative_path'].nil? && opts[:'relative_path'].to_s.length < 1
        fail ArgumentError, 'invalid value for "opts[:"relative_path"]" when calling ContentPackagesApi.create, the character length must be great than or equal to 1.'
      end

      if @api_client.config.client_side_validation && !opts[:'file_url'].nil? && opts[:'file_url'].to_s.length < 1
        fail ArgumentError, 'invalid value for "opts[:"file_url"]" when calling ContentPackagesApi.create, the character length must be great than or equal to 1.'
      end

      # resource path
      local_var_path = '/pulp/api/v3/content/rpm/packages/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']
      # HTTP header 'Content-Type'
      content_type = @api_client.select_header_content_type(['multipart/form-data', 'application/x-www-form-urlencoded'])
      if !content_type.nil?
          header_params['Content-Type'] = content_type
      end

      # form parameters
      form_params = opts[:form_params] || {}
      form_params['repository'] = opts[:'repository'] if !opts[:'repository'].nil?
      form_params['pulp_labels'] = opts[:'pulp_labels'] if !opts[:'pulp_labels'].nil?
      form_params['artifact'] = opts[:'artifact'] if !opts[:'artifact'].nil?
      form_params['relative_path'] = opts[:'relative_path'] if !opts[:'relative_path'].nil?
      form_params['file'] = opts[:'file'] if !opts[:'file'].nil?
      form_params['upload'] = opts[:'upload'] if !opts[:'upload'].nil?
      form_params['file_url'] = opts[:'file_url'] if !opts[:'file_url'].nil?

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'AsyncOperationResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"ContentPackagesApi.create",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentPackagesApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List packages
    # A ViewSet for Package.  Define endpoint name which will appear in the API endpoint for this content type. For example::     http://pulp.example.com/pulp/api/v3/content/rpm/packages/  Also specify queryset and serializer for Package.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :arch Filter results where arch matches value
    # @option opts [String] :arch__contains Filter results where arch contains value
    # @option opts [Array<String>] :arch__in Filter results where arch is in a comma-separated list of values
    # @option opts [String] :arch__ne Filter results where arch not equal to value
    # @option opts [String] :arch__startswith Filter results where arch starts with value
    # @option opts [String] :checksum_type Filter results where checksum_type matches value  * &#x60;unknown&#x60; - unknown * &#x60;md5&#x60; - md5 * &#x60;sha1&#x60; - sha1 * &#x60;sha1&#x60; - sha1 * &#x60;sha224&#x60; - sha224 * &#x60;sha256&#x60; - sha256 * &#x60;sha384&#x60; - sha384 * &#x60;sha512&#x60; - sha512
    # @option opts [Array<String>] :checksum_type__in Filter results where checksum_type is in a comma-separated list of values
    # @option opts [String] :checksum_type__ne Filter results where checksum_type not equal to value
    # @option opts [String] :epoch Filter results where epoch matches value
    # @option opts [Array<String>] :epoch__in Filter results where epoch is in a comma-separated list of values
    # @option opts [String] :epoch__ne Filter results where epoch not equal to value
    # @option opts [String] :filename 
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name Filter results where name matches value
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__ne Filter results where name not equal to value
    # @option opts [String] :name__startswith Filter results where name starts with value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering  * &#x60;pulp_id&#x60; - Pulp id * &#x60;-pulp_id&#x60; - Pulp id (descending) * &#x60;pulp_created&#x60; - Pulp created * &#x60;-pulp_created&#x60; - Pulp created (descending) * &#x60;pulp_last_updated&#x60; - Pulp last updated * &#x60;-pulp_last_updated&#x60; - Pulp last updated (descending) * &#x60;pulp_type&#x60; - Pulp type * &#x60;-pulp_type&#x60; - Pulp type (descending) * &#x60;upstream_id&#x60; - Upstream id * &#x60;-upstream_id&#x60; - Upstream id (descending) * &#x60;pulp_labels&#x60; - Pulp labels * &#x60;-pulp_labels&#x60; - Pulp labels (descending) * &#x60;timestamp_of_interest&#x60; - Timestamp of interest * &#x60;-timestamp_of_interest&#x60; - Timestamp of interest (descending) * &#x60;name&#x60; - Name * &#x60;-name&#x60; - Name (descending) * &#x60;epoch&#x60; - Epoch * &#x60;-epoch&#x60; - Epoch (descending) * &#x60;version&#x60; - Version * &#x60;-version&#x60; - Version (descending) * &#x60;release&#x60; - Release * &#x60;-release&#x60; - Release (descending) * &#x60;arch&#x60; - Arch * &#x60;-arch&#x60; - Arch (descending) * &#x60;evr&#x60; - Evr * &#x60;-evr&#x60; - Evr (descending) * &#x60;pkgId&#x60; - Pkgid * &#x60;-pkgId&#x60; - Pkgid (descending) * &#x60;checksum_type&#x60; - Checksum type * &#x60;-checksum_type&#x60; - Checksum type (descending) * &#x60;summary&#x60; - Summary * &#x60;-summary&#x60; - Summary (descending) * &#x60;description&#x60; - Description * &#x60;-description&#x60; - Description (descending) * &#x60;url&#x60; - Url * &#x60;-url&#x60; - Url (descending) * &#x60;changelogs&#x60; - Changelogs * &#x60;-changelogs&#x60; - Changelogs (descending) * &#x60;files&#x60; - Files * &#x60;-files&#x60; - Files (descending) * &#x60;requires&#x60; - Requires * &#x60;-requires&#x60; - Requires (descending) * &#x60;provides&#x60; - Provides * &#x60;-provides&#x60; - Provides (descending) * &#x60;conflicts&#x60; - Conflicts * &#x60;-conflicts&#x60; - Conflicts (descending) * &#x60;obsoletes&#x60; - Obsoletes * &#x60;-obsoletes&#x60; - Obsoletes (descending) * &#x60;suggests&#x60; - Suggests * &#x60;-suggests&#x60; - Suggests (descending) * &#x60;enhances&#x60; - Enhances * &#x60;-enhances&#x60; - Enhances (descending) * &#x60;recommends&#x60; - Recommends * &#x60;-recommends&#x60; - Recommends (descending) * &#x60;supplements&#x60; - Supplements * &#x60;-supplements&#x60; - Supplements (descending) * &#x60;location_base&#x60; - Location base * &#x60;-location_base&#x60; - Location base (descending) * &#x60;location_href&#x60; - Location href * &#x60;-location_href&#x60; - Location href (descending) * &#x60;rpm_buildhost&#x60; - Rpm buildhost * &#x60;-rpm_buildhost&#x60; - Rpm buildhost (descending) * &#x60;rpm_group&#x60; - Rpm group * &#x60;-rpm_group&#x60; - Rpm group (descending) * &#x60;rpm_license&#x60; - Rpm license * &#x60;-rpm_license&#x60; - Rpm license (descending) * &#x60;rpm_packager&#x60; - Rpm packager * &#x60;-rpm_packager&#x60; - Rpm packager (descending) * &#x60;rpm_sourcerpm&#x60; - Rpm sourcerpm * &#x60;-rpm_sourcerpm&#x60; - Rpm sourcerpm (descending) * &#x60;rpm_vendor&#x60; - Rpm vendor * &#x60;-rpm_vendor&#x60; - Rpm vendor (descending) * &#x60;rpm_header_start&#x60; - Rpm header start * &#x60;-rpm_header_start&#x60; - Rpm header start (descending) * &#x60;rpm_header_end&#x60; - Rpm header end * &#x60;-rpm_header_end&#x60; - Rpm header end (descending) * &#x60;size_archive&#x60; - Size archive * &#x60;-size_archive&#x60; - Size archive (descending) * &#x60;size_installed&#x60; - Size installed * &#x60;-size_installed&#x60; - Size installed (descending) * &#x60;size_package&#x60; - Size package * &#x60;-size_package&#x60; - Size package (descending) * &#x60;time_build&#x60; - Time build * &#x60;-time_build&#x60; - Time build (descending) * &#x60;time_file&#x60; - Time file * &#x60;-time_file&#x60; - Time file (descending) * &#x60;is_modular&#x60; - Is modular * &#x60;-is_modular&#x60; - Is modular (descending) * &#x60;pk&#x60; - Pk * &#x60;-pk&#x60; - Pk (descending)
    # @option opts [Float] :orphaned_for Minutes Content has been orphaned for. -1 uses ORPHAN_PROTECTION_TIME.
    # @option opts [String] :pkg_id Filter results where pkgId matches value
    # @option opts [Array<String>] :pkg_id__in Filter results where pkgId is in a comma-separated list of values
    # @option opts [Array<String>] :prn__in Multiple values may be separated by commas.
    # @option opts [Array<String>] :pulp_href__in Multiple values may be separated by commas.
    # @option opts [Array<String>] :pulp_id__in Multiple values may be separated by commas.
    # @option opts [String] :pulp_label_select Filter labels by search string
    # @option opts [String] :q Filter results by using NOT, AND and OR operations on other filters
    # @option opts [String] :release Filter results where release matches value
    # @option opts [String] :release__contains Filter results where release contains value
    # @option opts [Array<String>] :release__in Filter results where release is in a comma-separated list of values
    # @option opts [String] :release__ne Filter results where release not equal to value
    # @option opts [String] :release__startswith Filter results where release starts with value
    # @option opts [String] :repository_version Repository Version referenced by HREF/PRN
    # @option opts [String] :repository_version_added Repository Version referenced by HREF/PRN
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF/PRN
    # @option opts [String] :sha256 
    # @option opts [String] :version Filter results where version matches value
    # @option opts [Array<String>] :version__in Filter results where version is in a comma-separated list of values
    # @option opts [String] :version__ne Filter results where version not equal to value
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedrpmPackageResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List packages
    # A ViewSet for Package.  Define endpoint name which will appear in the API endpoint for this content type. For example::     http://pulp.example.com/pulp/api/v3/content/rpm/packages/  Also specify queryset and serializer for Package.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :arch Filter results where arch matches value
    # @option opts [String] :arch__contains Filter results where arch contains value
    # @option opts [Array<String>] :arch__in Filter results where arch is in a comma-separated list of values
    # @option opts [String] :arch__ne Filter results where arch not equal to value
    # @option opts [String] :arch__startswith Filter results where arch starts with value
    # @option opts [String] :checksum_type Filter results where checksum_type matches value  * &#x60;unknown&#x60; - unknown * &#x60;md5&#x60; - md5 * &#x60;sha1&#x60; - sha1 * &#x60;sha1&#x60; - sha1 * &#x60;sha224&#x60; - sha224 * &#x60;sha256&#x60; - sha256 * &#x60;sha384&#x60; - sha384 * &#x60;sha512&#x60; - sha512
    # @option opts [Array<String>] :checksum_type__in Filter results where checksum_type is in a comma-separated list of values
    # @option opts [String] :checksum_type__ne Filter results where checksum_type not equal to value
    # @option opts [String] :epoch Filter results where epoch matches value
    # @option opts [Array<String>] :epoch__in Filter results where epoch is in a comma-separated list of values
    # @option opts [String] :epoch__ne Filter results where epoch not equal to value
    # @option opts [String] :filename 
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name Filter results where name matches value
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__ne Filter results where name not equal to value
    # @option opts [String] :name__startswith Filter results where name starts with value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering  * &#x60;pulp_id&#x60; - Pulp id * &#x60;-pulp_id&#x60; - Pulp id (descending) * &#x60;pulp_created&#x60; - Pulp created * &#x60;-pulp_created&#x60; - Pulp created (descending) * &#x60;pulp_last_updated&#x60; - Pulp last updated * &#x60;-pulp_last_updated&#x60; - Pulp last updated (descending) * &#x60;pulp_type&#x60; - Pulp type * &#x60;-pulp_type&#x60; - Pulp type (descending) * &#x60;upstream_id&#x60; - Upstream id * &#x60;-upstream_id&#x60; - Upstream id (descending) * &#x60;pulp_labels&#x60; - Pulp labels * &#x60;-pulp_labels&#x60; - Pulp labels (descending) * &#x60;timestamp_of_interest&#x60; - Timestamp of interest * &#x60;-timestamp_of_interest&#x60; - Timestamp of interest (descending) * &#x60;name&#x60; - Name * &#x60;-name&#x60; - Name (descending) * &#x60;epoch&#x60; - Epoch * &#x60;-epoch&#x60; - Epoch (descending) * &#x60;version&#x60; - Version * &#x60;-version&#x60; - Version (descending) * &#x60;release&#x60; - Release * &#x60;-release&#x60; - Release (descending) * &#x60;arch&#x60; - Arch * &#x60;-arch&#x60; - Arch (descending) * &#x60;evr&#x60; - Evr * &#x60;-evr&#x60; - Evr (descending) * &#x60;pkgId&#x60; - Pkgid * &#x60;-pkgId&#x60; - Pkgid (descending) * &#x60;checksum_type&#x60; - Checksum type * &#x60;-checksum_type&#x60; - Checksum type (descending) * &#x60;summary&#x60; - Summary * &#x60;-summary&#x60; - Summary (descending) * &#x60;description&#x60; - Description * &#x60;-description&#x60; - Description (descending) * &#x60;url&#x60; - Url * &#x60;-url&#x60; - Url (descending) * &#x60;changelogs&#x60; - Changelogs * &#x60;-changelogs&#x60; - Changelogs (descending) * &#x60;files&#x60; - Files * &#x60;-files&#x60; - Files (descending) * &#x60;requires&#x60; - Requires * &#x60;-requires&#x60; - Requires (descending) * &#x60;provides&#x60; - Provides * &#x60;-provides&#x60; - Provides (descending) * &#x60;conflicts&#x60; - Conflicts * &#x60;-conflicts&#x60; - Conflicts (descending) * &#x60;obsoletes&#x60; - Obsoletes * &#x60;-obsoletes&#x60; - Obsoletes (descending) * &#x60;suggests&#x60; - Suggests * &#x60;-suggests&#x60; - Suggests (descending) * &#x60;enhances&#x60; - Enhances * &#x60;-enhances&#x60; - Enhances (descending) * &#x60;recommends&#x60; - Recommends * &#x60;-recommends&#x60; - Recommends (descending) * &#x60;supplements&#x60; - Supplements * &#x60;-supplements&#x60; - Supplements (descending) * &#x60;location_base&#x60; - Location base * &#x60;-location_base&#x60; - Location base (descending) * &#x60;location_href&#x60; - Location href * &#x60;-location_href&#x60; - Location href (descending) * &#x60;rpm_buildhost&#x60; - Rpm buildhost * &#x60;-rpm_buildhost&#x60; - Rpm buildhost (descending) * &#x60;rpm_group&#x60; - Rpm group * &#x60;-rpm_group&#x60; - Rpm group (descending) * &#x60;rpm_license&#x60; - Rpm license * &#x60;-rpm_license&#x60; - Rpm license (descending) * &#x60;rpm_packager&#x60; - Rpm packager * &#x60;-rpm_packager&#x60; - Rpm packager (descending) * &#x60;rpm_sourcerpm&#x60; - Rpm sourcerpm * &#x60;-rpm_sourcerpm&#x60; - Rpm sourcerpm (descending) * &#x60;rpm_vendor&#x60; - Rpm vendor * &#x60;-rpm_vendor&#x60; - Rpm vendor (descending) * &#x60;rpm_header_start&#x60; - Rpm header start * &#x60;-rpm_header_start&#x60; - Rpm header start (descending) * &#x60;rpm_header_end&#x60; - Rpm header end * &#x60;-rpm_header_end&#x60; - Rpm header end (descending) * &#x60;size_archive&#x60; - Size archive * &#x60;-size_archive&#x60; - Size archive (descending) * &#x60;size_installed&#x60; - Size installed * &#x60;-size_installed&#x60; - Size installed (descending) * &#x60;size_package&#x60; - Size package * &#x60;-size_package&#x60; - Size package (descending) * &#x60;time_build&#x60; - Time build * &#x60;-time_build&#x60; - Time build (descending) * &#x60;time_file&#x60; - Time file * &#x60;-time_file&#x60; - Time file (descending) * &#x60;is_modular&#x60; - Is modular * &#x60;-is_modular&#x60; - Is modular (descending) * &#x60;pk&#x60; - Pk * &#x60;-pk&#x60; - Pk (descending)
    # @option opts [Float] :orphaned_for Minutes Content has been orphaned for. -1 uses ORPHAN_PROTECTION_TIME.
    # @option opts [String] :pkg_id Filter results where pkgId matches value
    # @option opts [Array<String>] :pkg_id__in Filter results where pkgId is in a comma-separated list of values
    # @option opts [Array<String>] :prn__in Multiple values may be separated by commas.
    # @option opts [Array<String>] :pulp_href__in Multiple values may be separated by commas.
    # @option opts [Array<String>] :pulp_id__in Multiple values may be separated by commas.
    # @option opts [String] :pulp_label_select Filter labels by search string
    # @option opts [String] :q Filter results by using NOT, AND and OR operations on other filters
    # @option opts [String] :release Filter results where release matches value
    # @option opts [String] :release__contains Filter results where release contains value
    # @option opts [Array<String>] :release__in Filter results where release is in a comma-separated list of values
    # @option opts [String] :release__ne Filter results where release not equal to value
    # @option opts [String] :release__startswith Filter results where release starts with value
    # @option opts [String] :repository_version Repository Version referenced by HREF/PRN
    # @option opts [String] :repository_version_added Repository Version referenced by HREF/PRN
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF/PRN
    # @option opts [String] :sha256 
    # @option opts [String] :version Filter results where version matches value
    # @option opts [Array<String>] :version__in Filter results where version is in a comma-separated list of values
    # @option opts [String] :version__ne Filter results where version not equal to value
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedrpmPackageResponseList, Integer, Hash)>] PaginatedrpmPackageResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentPackagesApi.list ...'
      end
      allowable_values = ["md5", "sha1", "sha1", "sha224", "sha256", "sha384", "sha512", "unknown"]
      if @api_client.config.client_side_validation && opts[:'checksum_type'] && !allowable_values.include?(opts[:'checksum_type'])
        fail ArgumentError, "invalid value for \"checksum_type\", must be one of #{allowable_values}"
      end
      allowable_values = ["-arch", "-changelogs", "-checksum_type", "-conflicts", "-description", "-enhances", "-epoch", "-evr", "-files", "-is_modular", "-location_base", "-location_href", "-name", "-obsoletes", "-pk", "-pkgId", "-provides", "-pulp_created", "-pulp_id", "-pulp_labels", "-pulp_last_updated", "-pulp_type", "-recommends", "-release", "-requires", "-rpm_buildhost", "-rpm_group", "-rpm_header_end", "-rpm_header_start", "-rpm_license", "-rpm_packager", "-rpm_sourcerpm", "-rpm_vendor", "-size_archive", "-size_installed", "-size_package", "-suggests", "-summary", "-supplements", "-time_build", "-time_file", "-timestamp_of_interest", "-upstream_id", "-url", "-version", "arch", "changelogs", "checksum_type", "conflicts", "description", "enhances", "epoch", "evr", "files", "is_modular", "location_base", "location_href", "name", "obsoletes", "pk", "pkgId", "provides", "pulp_created", "pulp_id", "pulp_labels", "pulp_last_updated", "pulp_type", "recommends", "release", "requires", "rpm_buildhost", "rpm_group", "rpm_header_end", "rpm_header_start", "rpm_license", "rpm_packager", "rpm_sourcerpm", "rpm_vendor", "size_archive", "size_installed", "size_package", "suggests", "summary", "supplements", "time_build", "time_file", "timestamp_of_interest", "upstream_id", "url", "version"]
      if @api_client.config.client_side_validation && opts[:'ordering'] && !opts[:'ordering'].all? { |item| allowable_values.include?(item) }
        fail ArgumentError, "invalid value for \"ordering\", must include one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/rpm/packages/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'arch'] = opts[:'arch'] if !opts[:'arch'].nil?
      query_params[:'arch__contains'] = opts[:'arch__contains'] if !opts[:'arch__contains'].nil?
      query_params[:'arch__in'] = @api_client.build_collection_param(opts[:'arch__in'], :csv) if !opts[:'arch__in'].nil?
      query_params[:'arch__ne'] = opts[:'arch__ne'] if !opts[:'arch__ne'].nil?
      query_params[:'arch__startswith'] = opts[:'arch__startswith'] if !opts[:'arch__startswith'].nil?
      query_params[:'checksum_type'] = opts[:'checksum_type'] if !opts[:'checksum_type'].nil?
      query_params[:'checksum_type__in'] = @api_client.build_collection_param(opts[:'checksum_type__in'], :csv) if !opts[:'checksum_type__in'].nil?
      query_params[:'checksum_type__ne'] = opts[:'checksum_type__ne'] if !opts[:'checksum_type__ne'].nil?
      query_params[:'epoch'] = opts[:'epoch'] if !opts[:'epoch'].nil?
      query_params[:'epoch__in'] = @api_client.build_collection_param(opts[:'epoch__in'], :csv) if !opts[:'epoch__in'].nil?
      query_params[:'epoch__ne'] = opts[:'epoch__ne'] if !opts[:'epoch__ne'].nil?
      query_params[:'filename'] = opts[:'filename'] if !opts[:'filename'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'name__contains'] = opts[:'name__contains'] if !opts[:'name__contains'].nil?
      query_params[:'name__in'] = @api_client.build_collection_param(opts[:'name__in'], :csv) if !opts[:'name__in'].nil?
      query_params[:'name__ne'] = opts[:'name__ne'] if !opts[:'name__ne'].nil?
      query_params[:'name__startswith'] = opts[:'name__startswith'] if !opts[:'name__startswith'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = @api_client.build_collection_param(opts[:'ordering'], :csv) if !opts[:'ordering'].nil?
      query_params[:'orphaned_for'] = opts[:'orphaned_for'] if !opts[:'orphaned_for'].nil?
      query_params[:'pkgId'] = opts[:'pkg_id'] if !opts[:'pkg_id'].nil?
      query_params[:'pkgId__in'] = @api_client.build_collection_param(opts[:'pkg_id__in'], :csv) if !opts[:'pkg_id__in'].nil?
      query_params[:'prn__in'] = @api_client.build_collection_param(opts[:'prn__in'], :csv) if !opts[:'prn__in'].nil?
      query_params[:'pulp_href__in'] = @api_client.build_collection_param(opts[:'pulp_href__in'], :csv) if !opts[:'pulp_href__in'].nil?
      query_params[:'pulp_id__in'] = @api_client.build_collection_param(opts[:'pulp_id__in'], :csv) if !opts[:'pulp_id__in'].nil?
      query_params[:'pulp_label_select'] = opts[:'pulp_label_select'] if !opts[:'pulp_label_select'].nil?
      query_params[:'q'] = opts[:'q'] if !opts[:'q'].nil?
      query_params[:'release'] = opts[:'release'] if !opts[:'release'].nil?
      query_params[:'release__contains'] = opts[:'release__contains'] if !opts[:'release__contains'].nil?
      query_params[:'release__in'] = @api_client.build_collection_param(opts[:'release__in'], :csv) if !opts[:'release__in'].nil?
      query_params[:'release__ne'] = opts[:'release__ne'] if !opts[:'release__ne'].nil?
      query_params[:'release__startswith'] = opts[:'release__startswith'] if !opts[:'release__startswith'].nil?
      query_params[:'repository_version'] = opts[:'repository_version'] if !opts[:'repository_version'].nil?
      query_params[:'repository_version_added'] = opts[:'repository_version_added'] if !opts[:'repository_version_added'].nil?
      query_params[:'repository_version_removed'] = opts[:'repository_version_removed'] if !opts[:'repository_version_removed'].nil?
      query_params[:'sha256'] = opts[:'sha256'] if !opts[:'sha256'].nil?
      query_params[:'version'] = opts[:'version'] if !opts[:'version'].nil?
      query_params[:'version__in'] = @api_client.build_collection_param(opts[:'version__in'], :csv) if !opts[:'version__in'].nil?
      query_params[:'version__ne'] = opts[:'version__ne'] if !opts[:'version__ne'].nil?
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'PaginatedrpmPackageResponseList'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"ContentPackagesApi.list",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentPackagesApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a package
    # A ViewSet for Package.  Define endpoint name which will appear in the API endpoint for this content type. For example::     http://pulp.example.com/pulp/api/v3/content/rpm/packages/  Also specify queryset and serializer for Package.
    # @param rpm_package_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [RpmPackageResponse]
    def read(rpm_package_href, opts = {})
      data, _status_code, _headers = read_with_http_info(rpm_package_href, opts)
      data
    end

    # Inspect a package
    # A ViewSet for Package.  Define endpoint name which will appear in the API endpoint for this content type. For example::     http://pulp.example.com/pulp/api/v3/content/rpm/packages/  Also specify queryset and serializer for Package.
    # @param rpm_package_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(RpmPackageResponse, Integer, Hash)>] RpmPackageResponse data, response status code and response headers
    def read_with_http_info(rpm_package_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentPackagesApi.read ...'
      end
      # verify the required parameter 'rpm_package_href' is set
      if @api_client.config.client_side_validation && rpm_package_href.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_package_href' when calling ContentPackagesApi.read"
      end
      # resource path
      local_var_path = '{rpm_package_href}'.sub('{' + 'rpm_package_href' + '}', CGI.escape(rpm_package_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'RpmPackageResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"ContentPackagesApi.read",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentPackagesApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Set a label
    # Set a single pulp_label on the object to a specific value or null.
    # @param rpm_package_href [String] 
    # @param set_label [SetLabel] 
    # @param [Hash] opts the optional parameters
    # @return [SetLabelResponse]
    def set_label(rpm_package_href, set_label, opts = {})
      data, _status_code, _headers = set_label_with_http_info(rpm_package_href, set_label, opts)
      data
    end

    # Set a label
    # Set a single pulp_label on the object to a specific value or null.
    # @param rpm_package_href [String] 
    # @param set_label [SetLabel] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(SetLabelResponse, Integer, Hash)>] SetLabelResponse data, response status code and response headers
    def set_label_with_http_info(rpm_package_href, set_label, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentPackagesApi.set_label ...'
      end
      # verify the required parameter 'rpm_package_href' is set
      if @api_client.config.client_side_validation && rpm_package_href.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_package_href' when calling ContentPackagesApi.set_label"
      end
      # verify the required parameter 'set_label' is set
      if @api_client.config.client_side_validation && set_label.nil?
        fail ArgumentError, "Missing the required parameter 'set_label' when calling ContentPackagesApi.set_label"
      end
      # resource path
      local_var_path = '{rpm_package_href}set_label/'.sub('{' + 'rpm_package_href' + '}', CGI.escape(rpm_package_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']
      # HTTP header 'Content-Type'
      content_type = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])
      if !content_type.nil?
          header_params['Content-Type'] = content_type
      end

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(set_label)

      # return_type
      return_type = opts[:debug_return_type] || 'SetLabelResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"ContentPackagesApi.set_label",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentPackagesApi#set_label\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Unset a label
    # Unset a single pulp_label on the object.
    # @param rpm_package_href [String] 
    # @param unset_label [UnsetLabel] 
    # @param [Hash] opts the optional parameters
    # @return [UnsetLabelResponse]
    def unset_label(rpm_package_href, unset_label, opts = {})
      data, _status_code, _headers = unset_label_with_http_info(rpm_package_href, unset_label, opts)
      data
    end

    # Unset a label
    # Unset a single pulp_label on the object.
    # @param rpm_package_href [String] 
    # @param unset_label [UnsetLabel] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(UnsetLabelResponse, Integer, Hash)>] UnsetLabelResponse data, response status code and response headers
    def unset_label_with_http_info(rpm_package_href, unset_label, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentPackagesApi.unset_label ...'
      end
      # verify the required parameter 'rpm_package_href' is set
      if @api_client.config.client_side_validation && rpm_package_href.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_package_href' when calling ContentPackagesApi.unset_label"
      end
      # verify the required parameter 'unset_label' is set
      if @api_client.config.client_side_validation && unset_label.nil?
        fail ArgumentError, "Missing the required parameter 'unset_label' when calling ContentPackagesApi.unset_label"
      end
      # resource path
      local_var_path = '{rpm_package_href}unset_label/'.sub('{' + 'rpm_package_href' + '}', CGI.escape(rpm_package_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']
      # HTTP header 'Content-Type'
      content_type = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])
      if !content_type.nil?
          header_params['Content-Type'] = content_type
      end

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(unset_label)

      # return_type
      return_type = opts[:debug_return_type] || 'UnsetLabelResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"ContentPackagesApi.unset_label",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentPackagesApi#unset_label\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
