=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
Generator version: 7.10.0

=end

require 'cgi'

module PulpRpmClient
  class PublicationsRpmApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Add a role
    # Add a role for this object to users/groups.
    # @param rpm_rpm_publication_href [String] 
    # @param nested_role [NestedRole] 
    # @param [Hash] opts the optional parameters
    # @return [NestedRoleResponse]
    def add_role(rpm_rpm_publication_href, nested_role, opts = {})
      data, _status_code, _headers = add_role_with_http_info(rpm_rpm_publication_href, nested_role, opts)
      data
    end

    # Add a role
    # Add a role for this object to users/groups.
    # @param rpm_rpm_publication_href [String] 
    # @param nested_role [NestedRole] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(NestedRoleResponse, Integer, Hash)>] NestedRoleResponse data, response status code and response headers
    def add_role_with_http_info(rpm_rpm_publication_href, nested_role, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PublicationsRpmApi.add_role ...'
      end
      # verify the required parameter 'rpm_rpm_publication_href' is set
      if @api_client.config.client_side_validation && rpm_rpm_publication_href.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_rpm_publication_href' when calling PublicationsRpmApi.add_role"
      end
      # verify the required parameter 'nested_role' is set
      if @api_client.config.client_side_validation && nested_role.nil?
        fail ArgumentError, "Missing the required parameter 'nested_role' when calling PublicationsRpmApi.add_role"
      end
      # resource path
      local_var_path = '{rpm_rpm_publication_href}add_role/'.sub('{' + 'rpm_rpm_publication_href' + '}', CGI.escape(rpm_rpm_publication_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']
      # HTTP header 'Content-Type'
      content_type = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])
      if !content_type.nil?
          header_params['Content-Type'] = content_type
      end

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(nested_role)

      # return_type
      return_type = opts[:debug_return_type] || 'NestedRoleResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"PublicationsRpmApi.add_role",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PublicationsRpmApi#add_role\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Create a rpm publication
    # Trigger an asynchronous task to create a new RPM content publication.
    # @param rpm_rpm_publication [RpmRpmPublication] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def create(rpm_rpm_publication, opts = {})
      data, _status_code, _headers = create_with_http_info(rpm_rpm_publication, opts)
      data
    end

    # Create a rpm publication
    # Trigger an asynchronous task to create a new RPM content publication.
    # @param rpm_rpm_publication [RpmRpmPublication] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def create_with_http_info(rpm_rpm_publication, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PublicationsRpmApi.create ...'
      end
      # verify the required parameter 'rpm_rpm_publication' is set
      if @api_client.config.client_side_validation && rpm_rpm_publication.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_rpm_publication' when calling PublicationsRpmApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/publications/rpm/rpm/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']
      # HTTP header 'Content-Type'
      content_type = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])
      if !content_type.nil?
          header_params['Content-Type'] = content_type
      end

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(rpm_rpm_publication)

      # return_type
      return_type = opts[:debug_return_type] || 'AsyncOperationResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"PublicationsRpmApi.create",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PublicationsRpmApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete a rpm publication
    # ViewSet for Rpm Publications.
    # @param rpm_rpm_publication_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete(rpm_rpm_publication_href, opts = {})
      delete_with_http_info(rpm_rpm_publication_href, opts)
      nil
    end

    # Delete a rpm publication
    # ViewSet for Rpm Publications.
    # @param rpm_rpm_publication_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def delete_with_http_info(rpm_rpm_publication_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PublicationsRpmApi.delete ...'
      end
      # verify the required parameter 'rpm_rpm_publication_href' is set
      if @api_client.config.client_side_validation && rpm_rpm_publication_href.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_rpm_publication_href' when calling PublicationsRpmApi.delete"
      end
      # resource path
      local_var_path = '{rpm_rpm_publication_href}'.sub('{' + 'rpm_rpm_publication_href' + '}', CGI.escape(rpm_rpm_publication_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type]

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"PublicationsRpmApi.delete",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PublicationsRpmApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List rpm publications
    # ViewSet for Rpm Publications.
    # @param [Hash] opts the optional parameters
    # @option opts [Boolean] :checkpoint Filter results where checkpoint matches value
    # @option opts [String] :content Content Unit referenced by HREF/PRN
    # @option opts [Array<String>] :content__in Multiple values may be separated by commas.
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering  * &#x60;pulp_id&#x60; - Pulp id * &#x60;-pulp_id&#x60; - Pulp id (descending) * &#x60;pulp_created&#x60; - Pulp created * &#x60;-pulp_created&#x60; - Pulp created (descending) * &#x60;pulp_last_updated&#x60; - Pulp last updated * &#x60;-pulp_last_updated&#x60; - Pulp last updated (descending) * &#x60;pulp_type&#x60; - Pulp type * &#x60;-pulp_type&#x60; - Pulp type (descending) * &#x60;complete&#x60; - Complete * &#x60;-complete&#x60; - Complete (descending) * &#x60;pass_through&#x60; - Pass through * &#x60;-pass_through&#x60; - Pass through (descending) * &#x60;checkpoint&#x60; - Checkpoint * &#x60;-checkpoint&#x60; - Checkpoint (descending) * &#x60;pk&#x60; - Pk * &#x60;-pk&#x60; - Pk (descending)
    # @option opts [Array<String>] :prn__in Multiple values may be separated by commas.
    # @option opts [Time] :pulp_created Filter results where pulp_created matches value
    # @option opts [Time] :pulp_created__gt Filter results where pulp_created is greater than value
    # @option opts [Time] :pulp_created__gte Filter results where pulp_created is greater than or equal to value
    # @option opts [Boolean] :pulp_created__isnull Filter results where pulp_created has a null value
    # @option opts [Time] :pulp_created__lt Filter results where pulp_created is less than value
    # @option opts [Time] :pulp_created__lte Filter results where pulp_created is less than or equal to value
    # @option opts [Array<Time>] :pulp_created__range Filter results where pulp_created is between two comma separated values
    # @option opts [Array<String>] :pulp_href__in Multiple values may be separated by commas.
    # @option opts [Array<String>] :pulp_id__in Multiple values may be separated by commas.
    # @option opts [String] :q Filter results by using NOT, AND and OR operations on other filters
    # @option opts [String] :repository Repository referenced by HREF/PRN
    # @option opts [String] :repository_version Repository Version referenced by HREF/PRN
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedrpmRpmPublicationResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List rpm publications
    # ViewSet for Rpm Publications.
    # @param [Hash] opts the optional parameters
    # @option opts [Boolean] :checkpoint Filter results where checkpoint matches value
    # @option opts [String] :content Content Unit referenced by HREF/PRN
    # @option opts [Array<String>] :content__in Multiple values may be separated by commas.
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering  * &#x60;pulp_id&#x60; - Pulp id * &#x60;-pulp_id&#x60; - Pulp id (descending) * &#x60;pulp_created&#x60; - Pulp created * &#x60;-pulp_created&#x60; - Pulp created (descending) * &#x60;pulp_last_updated&#x60; - Pulp last updated * &#x60;-pulp_last_updated&#x60; - Pulp last updated (descending) * &#x60;pulp_type&#x60; - Pulp type * &#x60;-pulp_type&#x60; - Pulp type (descending) * &#x60;complete&#x60; - Complete * &#x60;-complete&#x60; - Complete (descending) * &#x60;pass_through&#x60; - Pass through * &#x60;-pass_through&#x60; - Pass through (descending) * &#x60;checkpoint&#x60; - Checkpoint * &#x60;-checkpoint&#x60; - Checkpoint (descending) * &#x60;pk&#x60; - Pk * &#x60;-pk&#x60; - Pk (descending)
    # @option opts [Array<String>] :prn__in Multiple values may be separated by commas.
    # @option opts [Time] :pulp_created Filter results where pulp_created matches value
    # @option opts [Time] :pulp_created__gt Filter results where pulp_created is greater than value
    # @option opts [Time] :pulp_created__gte Filter results where pulp_created is greater than or equal to value
    # @option opts [Boolean] :pulp_created__isnull Filter results where pulp_created has a null value
    # @option opts [Time] :pulp_created__lt Filter results where pulp_created is less than value
    # @option opts [Time] :pulp_created__lte Filter results where pulp_created is less than or equal to value
    # @option opts [Array<Time>] :pulp_created__range Filter results where pulp_created is between two comma separated values
    # @option opts [Array<String>] :pulp_href__in Multiple values may be separated by commas.
    # @option opts [Array<String>] :pulp_id__in Multiple values may be separated by commas.
    # @option opts [String] :q Filter results by using NOT, AND and OR operations on other filters
    # @option opts [String] :repository Repository referenced by HREF/PRN
    # @option opts [String] :repository_version Repository Version referenced by HREF/PRN
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedrpmRpmPublicationResponseList, Integer, Hash)>] PaginatedrpmRpmPublicationResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PublicationsRpmApi.list ...'
      end
      allowable_values = ["-checkpoint", "-complete", "-pass_through", "-pk", "-pulp_created", "-pulp_id", "-pulp_last_updated", "-pulp_type", "checkpoint", "complete", "pass_through", "pk", "pulp_created", "pulp_id", "pulp_last_updated", "pulp_type"]
      if @api_client.config.client_side_validation && opts[:'ordering'] && !opts[:'ordering'].all? { |item| allowable_values.include?(item) }
        fail ArgumentError, "invalid value for \"ordering\", must include one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/pulp/api/v3/publications/rpm/rpm/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'checkpoint'] = opts[:'checkpoint'] if !opts[:'checkpoint'].nil?
      query_params[:'content'] = opts[:'content'] if !opts[:'content'].nil?
      query_params[:'content__in'] = @api_client.build_collection_param(opts[:'content__in'], :csv) if !opts[:'content__in'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = @api_client.build_collection_param(opts[:'ordering'], :csv) if !opts[:'ordering'].nil?
      query_params[:'prn__in'] = @api_client.build_collection_param(opts[:'prn__in'], :csv) if !opts[:'prn__in'].nil?
      query_params[:'pulp_created'] = opts[:'pulp_created'] if !opts[:'pulp_created'].nil?
      query_params[:'pulp_created__gt'] = opts[:'pulp_created__gt'] if !opts[:'pulp_created__gt'].nil?
      query_params[:'pulp_created__gte'] = opts[:'pulp_created__gte'] if !opts[:'pulp_created__gte'].nil?
      query_params[:'pulp_created__isnull'] = opts[:'pulp_created__isnull'] if !opts[:'pulp_created__isnull'].nil?
      query_params[:'pulp_created__lt'] = opts[:'pulp_created__lt'] if !opts[:'pulp_created__lt'].nil?
      query_params[:'pulp_created__lte'] = opts[:'pulp_created__lte'] if !opts[:'pulp_created__lte'].nil?
      query_params[:'pulp_created__range'] = @api_client.build_collection_param(opts[:'pulp_created__range'], :csv) if !opts[:'pulp_created__range'].nil?
      query_params[:'pulp_href__in'] = @api_client.build_collection_param(opts[:'pulp_href__in'], :csv) if !opts[:'pulp_href__in'].nil?
      query_params[:'pulp_id__in'] = @api_client.build_collection_param(opts[:'pulp_id__in'], :csv) if !opts[:'pulp_id__in'].nil?
      query_params[:'q'] = opts[:'q'] if !opts[:'q'].nil?
      query_params[:'repository'] = opts[:'repository'] if !opts[:'repository'].nil?
      query_params[:'repository_version'] = opts[:'repository_version'] if !opts[:'repository_version'].nil?
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'PaginatedrpmRpmPublicationResponseList'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"PublicationsRpmApi.list",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PublicationsRpmApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List roles
    # List roles assigned to this object.
    # @param rpm_rpm_publication_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [ObjectRolesResponse]
    def list_roles(rpm_rpm_publication_href, opts = {})
      data, _status_code, _headers = list_roles_with_http_info(rpm_rpm_publication_href, opts)
      data
    end

    # List roles
    # List roles assigned to this object.
    # @param rpm_rpm_publication_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(ObjectRolesResponse, Integer, Hash)>] ObjectRolesResponse data, response status code and response headers
    def list_roles_with_http_info(rpm_rpm_publication_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PublicationsRpmApi.list_roles ...'
      end
      # verify the required parameter 'rpm_rpm_publication_href' is set
      if @api_client.config.client_side_validation && rpm_rpm_publication_href.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_rpm_publication_href' when calling PublicationsRpmApi.list_roles"
      end
      # resource path
      local_var_path = '{rpm_rpm_publication_href}list_roles/'.sub('{' + 'rpm_rpm_publication_href' + '}', CGI.escape(rpm_rpm_publication_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'ObjectRolesResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"PublicationsRpmApi.list_roles",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PublicationsRpmApi#list_roles\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List user permissions
    # List permissions available to the current user on this object.
    # @param rpm_rpm_publication_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [MyPermissionsResponse]
    def my_permissions(rpm_rpm_publication_href, opts = {})
      data, _status_code, _headers = my_permissions_with_http_info(rpm_rpm_publication_href, opts)
      data
    end

    # List user permissions
    # List permissions available to the current user on this object.
    # @param rpm_rpm_publication_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(MyPermissionsResponse, Integer, Hash)>] MyPermissionsResponse data, response status code and response headers
    def my_permissions_with_http_info(rpm_rpm_publication_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PublicationsRpmApi.my_permissions ...'
      end
      # verify the required parameter 'rpm_rpm_publication_href' is set
      if @api_client.config.client_side_validation && rpm_rpm_publication_href.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_rpm_publication_href' when calling PublicationsRpmApi.my_permissions"
      end
      # resource path
      local_var_path = '{rpm_rpm_publication_href}my_permissions/'.sub('{' + 'rpm_rpm_publication_href' + '}', CGI.escape(rpm_rpm_publication_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'MyPermissionsResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"PublicationsRpmApi.my_permissions",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PublicationsRpmApi#my_permissions\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a rpm publication
    # ViewSet for Rpm Publications.
    # @param rpm_rpm_publication_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [RpmRpmPublicationResponse]
    def read(rpm_rpm_publication_href, opts = {})
      data, _status_code, _headers = read_with_http_info(rpm_rpm_publication_href, opts)
      data
    end

    # Inspect a rpm publication
    # ViewSet for Rpm Publications.
    # @param rpm_rpm_publication_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(RpmRpmPublicationResponse, Integer, Hash)>] RpmRpmPublicationResponse data, response status code and response headers
    def read_with_http_info(rpm_rpm_publication_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PublicationsRpmApi.read ...'
      end
      # verify the required parameter 'rpm_rpm_publication_href' is set
      if @api_client.config.client_side_validation && rpm_rpm_publication_href.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_rpm_publication_href' when calling PublicationsRpmApi.read"
      end
      # resource path
      local_var_path = '{rpm_rpm_publication_href}'.sub('{' + 'rpm_rpm_publication_href' + '}', CGI.escape(rpm_rpm_publication_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'RpmRpmPublicationResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"PublicationsRpmApi.read",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PublicationsRpmApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Remove a role
    # Remove a role for this object from users/groups.
    # @param rpm_rpm_publication_href [String] 
    # @param nested_role [NestedRole] 
    # @param [Hash] opts the optional parameters
    # @return [NestedRoleResponse]
    def remove_role(rpm_rpm_publication_href, nested_role, opts = {})
      data, _status_code, _headers = remove_role_with_http_info(rpm_rpm_publication_href, nested_role, opts)
      data
    end

    # Remove a role
    # Remove a role for this object from users/groups.
    # @param rpm_rpm_publication_href [String] 
    # @param nested_role [NestedRole] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(NestedRoleResponse, Integer, Hash)>] NestedRoleResponse data, response status code and response headers
    def remove_role_with_http_info(rpm_rpm_publication_href, nested_role, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PublicationsRpmApi.remove_role ...'
      end
      # verify the required parameter 'rpm_rpm_publication_href' is set
      if @api_client.config.client_side_validation && rpm_rpm_publication_href.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_rpm_publication_href' when calling PublicationsRpmApi.remove_role"
      end
      # verify the required parameter 'nested_role' is set
      if @api_client.config.client_side_validation && nested_role.nil?
        fail ArgumentError, "Missing the required parameter 'nested_role' when calling PublicationsRpmApi.remove_role"
      end
      # resource path
      local_var_path = '{rpm_rpm_publication_href}remove_role/'.sub('{' + 'rpm_rpm_publication_href' + '}', CGI.escape(rpm_rpm_publication_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']
      # HTTP header 'Content-Type'
      content_type = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])
      if !content_type.nil?
          header_params['Content-Type'] = content_type
      end

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(nested_role)

      # return_type
      return_type = opts[:debug_return_type] || 'NestedRoleResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"PublicationsRpmApi.remove_role",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PublicationsRpmApi#remove_role\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
