=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
Generator version: 7.10.0

=end

require 'cgi'

module PulpRpmClient
  class RepositoriesRpmVersionsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Delete a repository version
    # Trigger an asynchronous task to delete a repository version.
    # @param rpm_rpm_repository_version_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def delete(rpm_rpm_repository_version_href, opts = {})
      data, _status_code, _headers = delete_with_http_info(rpm_rpm_repository_version_href, opts)
      data
    end

    # Delete a repository version
    # Trigger an asynchronous task to delete a repository version.
    # @param rpm_rpm_repository_version_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def delete_with_http_info(rpm_rpm_repository_version_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesRpmVersionsApi.delete ...'
      end
      # verify the required parameter 'rpm_rpm_repository_version_href' is set
      if @api_client.config.client_side_validation && rpm_rpm_repository_version_href.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_rpm_repository_version_href' when calling RepositoriesRpmVersionsApi.delete"
      end
      # resource path
      local_var_path = '{rpm_rpm_repository_version_href}'.sub('{' + 'rpm_rpm_repository_version_href' + '}', CGI.escape(rpm_rpm_repository_version_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'AsyncOperationResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"RepositoriesRpmVersionsApi.delete",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesRpmVersionsApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List repository versions
    # RpmRepositoryVersion represents a single rpm repository version.
    # @param rpm_rpm_repository_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :content Content Unit referenced by HREF/PRN
    # @option opts [Array<String>] :content__in Multiple values may be separated by commas.
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :number Filter results where number matches value
    # @option opts [Integer] :number__gt Filter results where number is greater than value
    # @option opts [Integer] :number__gte Filter results where number is greater than or equal to value
    # @option opts [Integer] :number__lt Filter results where number is less than value
    # @option opts [Integer] :number__lte Filter results where number is less than or equal to value
    # @option opts [Array<Integer>] :number__range Filter results where number is between two comma separated values
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering  * &#x60;pulp_id&#x60; - Pulp id * &#x60;-pulp_id&#x60; - Pulp id (descending) * &#x60;pulp_created&#x60; - Pulp created * &#x60;-pulp_created&#x60; - Pulp created (descending) * &#x60;pulp_last_updated&#x60; - Pulp last updated * &#x60;-pulp_last_updated&#x60; - Pulp last updated (descending) * &#x60;number&#x60; - Number * &#x60;-number&#x60; - Number (descending) * &#x60;complete&#x60; - Complete * &#x60;-complete&#x60; - Complete (descending) * &#x60;info&#x60; - Info * &#x60;-info&#x60; - Info (descending) * &#x60;pk&#x60; - Pk * &#x60;-pk&#x60; - Pk (descending)
    # @option opts [Array<String>] :prn__in Multiple values may be separated by commas.
    # @option opts [Time] :pulp_created Filter results where pulp_created matches value
    # @option opts [Time] :pulp_created__gt Filter results where pulp_created is greater than value
    # @option opts [Time] :pulp_created__gte Filter results where pulp_created is greater than or equal to value
    # @option opts [Boolean] :pulp_created__isnull Filter results where pulp_created has a null value
    # @option opts [Time] :pulp_created__lt Filter results where pulp_created is less than value
    # @option opts [Time] :pulp_created__lte Filter results where pulp_created is less than or equal to value
    # @option opts [Array<Time>] :pulp_created__range Filter results where pulp_created is between two comma separated values
    # @option opts [Array<String>] :pulp_href__in Multiple values may be separated by commas.
    # @option opts [String] :q Filter results by using NOT, AND and OR operations on other filters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedRepositoryVersionResponseList]
    def list(rpm_rpm_repository_href, opts = {})
      data, _status_code, _headers = list_with_http_info(rpm_rpm_repository_href, opts)
      data
    end

    # List repository versions
    # RpmRepositoryVersion represents a single rpm repository version.
    # @param rpm_rpm_repository_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :content Content Unit referenced by HREF/PRN
    # @option opts [Array<String>] :content__in Multiple values may be separated by commas.
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :number Filter results where number matches value
    # @option opts [Integer] :number__gt Filter results where number is greater than value
    # @option opts [Integer] :number__gte Filter results where number is greater than or equal to value
    # @option opts [Integer] :number__lt Filter results where number is less than value
    # @option opts [Integer] :number__lte Filter results where number is less than or equal to value
    # @option opts [Array<Integer>] :number__range Filter results where number is between two comma separated values
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering  * &#x60;pulp_id&#x60; - Pulp id * &#x60;-pulp_id&#x60; - Pulp id (descending) * &#x60;pulp_created&#x60; - Pulp created * &#x60;-pulp_created&#x60; - Pulp created (descending) * &#x60;pulp_last_updated&#x60; - Pulp last updated * &#x60;-pulp_last_updated&#x60; - Pulp last updated (descending) * &#x60;number&#x60; - Number * &#x60;-number&#x60; - Number (descending) * &#x60;complete&#x60; - Complete * &#x60;-complete&#x60; - Complete (descending) * &#x60;info&#x60; - Info * &#x60;-info&#x60; - Info (descending) * &#x60;pk&#x60; - Pk * &#x60;-pk&#x60; - Pk (descending)
    # @option opts [Array<String>] :prn__in Multiple values may be separated by commas.
    # @option opts [Time] :pulp_created Filter results where pulp_created matches value
    # @option opts [Time] :pulp_created__gt Filter results where pulp_created is greater than value
    # @option opts [Time] :pulp_created__gte Filter results where pulp_created is greater than or equal to value
    # @option opts [Boolean] :pulp_created__isnull Filter results where pulp_created has a null value
    # @option opts [Time] :pulp_created__lt Filter results where pulp_created is less than value
    # @option opts [Time] :pulp_created__lte Filter results where pulp_created is less than or equal to value
    # @option opts [Array<Time>] :pulp_created__range Filter results where pulp_created is between two comma separated values
    # @option opts [Array<String>] :pulp_href__in Multiple values may be separated by commas.
    # @option opts [String] :q Filter results by using NOT, AND and OR operations on other filters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedRepositoryVersionResponseList, Integer, Hash)>] PaginatedRepositoryVersionResponseList data, response status code and response headers
    def list_with_http_info(rpm_rpm_repository_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesRpmVersionsApi.list ...'
      end
      # verify the required parameter 'rpm_rpm_repository_href' is set
      if @api_client.config.client_side_validation && rpm_rpm_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_rpm_repository_href' when calling RepositoriesRpmVersionsApi.list"
      end
      allowable_values = ["-complete", "-info", "-number", "-pk", "-pulp_created", "-pulp_id", "-pulp_last_updated", "complete", "info", "number", "pk", "pulp_created", "pulp_id", "pulp_last_updated"]
      if @api_client.config.client_side_validation && opts[:'ordering'] && !opts[:'ordering'].all? { |item| allowable_values.include?(item) }
        fail ArgumentError, "invalid value for \"ordering\", must include one of #{allowable_values}"
      end
      # resource path
      local_var_path = '{rpm_rpm_repository_href}versions/'.sub('{' + 'rpm_rpm_repository_href' + '}', CGI.escape(rpm_rpm_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'content'] = opts[:'content'] if !opts[:'content'].nil?
      query_params[:'content__in'] = @api_client.build_collection_param(opts[:'content__in'], :csv) if !opts[:'content__in'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'number'] = opts[:'number'] if !opts[:'number'].nil?
      query_params[:'number__gt'] = opts[:'number__gt'] if !opts[:'number__gt'].nil?
      query_params[:'number__gte'] = opts[:'number__gte'] if !opts[:'number__gte'].nil?
      query_params[:'number__lt'] = opts[:'number__lt'] if !opts[:'number__lt'].nil?
      query_params[:'number__lte'] = opts[:'number__lte'] if !opts[:'number__lte'].nil?
      query_params[:'number__range'] = @api_client.build_collection_param(opts[:'number__range'], :csv) if !opts[:'number__range'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = @api_client.build_collection_param(opts[:'ordering'], :csv) if !opts[:'ordering'].nil?
      query_params[:'prn__in'] = @api_client.build_collection_param(opts[:'prn__in'], :csv) if !opts[:'prn__in'].nil?
      query_params[:'pulp_created'] = opts[:'pulp_created'] if !opts[:'pulp_created'].nil?
      query_params[:'pulp_created__gt'] = opts[:'pulp_created__gt'] if !opts[:'pulp_created__gt'].nil?
      query_params[:'pulp_created__gte'] = opts[:'pulp_created__gte'] if !opts[:'pulp_created__gte'].nil?
      query_params[:'pulp_created__isnull'] = opts[:'pulp_created__isnull'] if !opts[:'pulp_created__isnull'].nil?
      query_params[:'pulp_created__lt'] = opts[:'pulp_created__lt'] if !opts[:'pulp_created__lt'].nil?
      query_params[:'pulp_created__lte'] = opts[:'pulp_created__lte'] if !opts[:'pulp_created__lte'].nil?
      query_params[:'pulp_created__range'] = @api_client.build_collection_param(opts[:'pulp_created__range'], :csv) if !opts[:'pulp_created__range'].nil?
      query_params[:'pulp_href__in'] = @api_client.build_collection_param(opts[:'pulp_href__in'], :csv) if !opts[:'pulp_href__in'].nil?
      query_params[:'q'] = opts[:'q'] if !opts[:'q'].nil?
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'PaginatedRepositoryVersionResponseList'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"RepositoriesRpmVersionsApi.list",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesRpmVersionsApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a repository version
    # RpmRepositoryVersion represents a single rpm repository version.
    # @param rpm_rpm_repository_version_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [RepositoryVersionResponse]
    def read(rpm_rpm_repository_version_href, opts = {})
      data, _status_code, _headers = read_with_http_info(rpm_rpm_repository_version_href, opts)
      data
    end

    # Inspect a repository version
    # RpmRepositoryVersion represents a single rpm repository version.
    # @param rpm_rpm_repository_version_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(RepositoryVersionResponse, Integer, Hash)>] RepositoryVersionResponse data, response status code and response headers
    def read_with_http_info(rpm_rpm_repository_version_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesRpmVersionsApi.read ...'
      end
      # verify the required parameter 'rpm_rpm_repository_version_href' is set
      if @api_client.config.client_side_validation && rpm_rpm_repository_version_href.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_rpm_repository_version_href' when calling RepositoriesRpmVersionsApi.read"
      end
      # resource path
      local_var_path = '{rpm_rpm_repository_version_href}'.sub('{' + 'rpm_rpm_repository_version_href' + '}', CGI.escape(rpm_rpm_repository_version_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'RepositoryVersionResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"RepositoriesRpmVersionsApi.read",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesRpmVersionsApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Trigger an asynchronous task to repair a repository version.
    # @param rpm_rpm_repository_version_href [String] 
    # @param repair [Repair] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def repair(rpm_rpm_repository_version_href, repair, opts = {})
      data, _status_code, _headers = repair_with_http_info(rpm_rpm_repository_version_href, repair, opts)
      data
    end

    # Trigger an asynchronous task to repair a repository version.
    # @param rpm_rpm_repository_version_href [String] 
    # @param repair [Repair] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def repair_with_http_info(rpm_rpm_repository_version_href, repair, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesRpmVersionsApi.repair ...'
      end
      # verify the required parameter 'rpm_rpm_repository_version_href' is set
      if @api_client.config.client_side_validation && rpm_rpm_repository_version_href.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_rpm_repository_version_href' when calling RepositoriesRpmVersionsApi.repair"
      end
      # verify the required parameter 'repair' is set
      if @api_client.config.client_side_validation && repair.nil?
        fail ArgumentError, "Missing the required parameter 'repair' when calling RepositoriesRpmVersionsApi.repair"
      end
      # resource path
      local_var_path = '{rpm_rpm_repository_version_href}repair/'.sub('{' + 'rpm_rpm_repository_version_href' + '}', CGI.escape(rpm_rpm_repository_version_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']
      # HTTP header 'Content-Type'
      content_type = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])
      if !content_type.nil?
          header_params['Content-Type'] = content_type
      end

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(repair)

      # return_type
      return_type = opts[:debug_return_type] || 'AsyncOperationResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"RepositoriesRpmVersionsApi.repair",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesRpmVersionsApi#repair\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
