=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
Generator version: 7.10.0

=end

require 'cgi'

module PulpRpmClient
  class RpmCompsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Upload comps.xml
    # Trigger an asynchronous task to upload a comps.xml file.
    # @param file [File] Full path of a comps.xml file that may be parsed into comps.xml Content units.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :repository URI of an RPM repository the comps.xml content units should be associated to.
    # @option opts [Boolean] :replace If true, incoming comps.xml replaces existing comps-related ContentUnits in the specified repository.
    # @return [AsyncOperationResponse]
    def rpm_comps_upload(file, opts = {})
      data, _status_code, _headers = rpm_comps_upload_with_http_info(file, opts)
      data
    end

    # Upload comps.xml
    # Trigger an asynchronous task to upload a comps.xml file.
    # @param file [File] Full path of a comps.xml file that may be parsed into comps.xml Content units.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :repository URI of an RPM repository the comps.xml content units should be associated to.
    # @option opts [Boolean] :replace If true, incoming comps.xml replaces existing comps-related ContentUnits in the specified repository.
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def rpm_comps_upload_with_http_info(file, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RpmCompsApi.rpm_comps_upload ...'
      end
      # verify the required parameter 'file' is set
      if @api_client.config.client_side_validation && file.nil?
        fail ArgumentError, "Missing the required parameter 'file' when calling RpmCompsApi.rpm_comps_upload"
      end
      # resource path
      local_var_path = '/pulp/api/v3/rpm/comps/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']
      # HTTP header 'Content-Type'
      content_type = @api_client.select_header_content_type(['multipart/form-data', 'application/x-www-form-urlencoded'])
      if !content_type.nil?
          header_params['Content-Type'] = content_type
      end

      # form parameters
      form_params = opts[:form_params] || {}
      form_params['file'] = file
      form_params['repository'] = opts[:'repository'] if !opts[:'repository'].nil?
      form_params['replace'] = opts[:'replace'] if !opts[:'replace'].nil?

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'AsyncOperationResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"RpmCompsApi.rpm_comps_upload",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RpmCompsApi#rpm_comps_upload\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
