=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
Generator version: 7.10.0

=end

require 'cgi'

module PulpRpmClient
  class RpmCopyApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Copy content
    # Trigger an asynchronous task to copy RPM contentfrom one repository into another, creating a newrepository version.
    # @param copy [Copy] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def copy_content(copy, opts = {})
      data, _status_code, _headers = copy_content_with_http_info(copy, opts)
      data
    end

    # Copy content
    # Trigger an asynchronous task to copy RPM contentfrom one repository into another, creating a newrepository version.
    # @param copy [Copy] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def copy_content_with_http_info(copy, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RpmCopyApi.copy_content ...'
      end
      # verify the required parameter 'copy' is set
      if @api_client.config.client_side_validation && copy.nil?
        fail ArgumentError, "Missing the required parameter 'copy' when calling RpmCopyApi.copy_content"
      end
      # resource path
      local_var_path = '/pulp/api/v3/rpm/copy/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']
      # HTTP header 'Content-Type'
      content_type = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])
      if !content_type.nil?
          header_params['Content-Type'] = content_type
      end

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(copy)

      # return_type
      return_type = opts[:debug_return_type] || 'AsyncOperationResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"RpmCopyApi.copy_content",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RpmCopyApi#copy_content\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
