=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
Generator version: 7.10.0

=end

require 'cgi'

module PulpRpmClient
  class RpmPruneApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Trigger an asynchronous old-Package-prune operation.
    # @param prune_packages [PrunePackages] 
    # @param [Hash] opts the optional parameters
    # @return [TaskGroupOperationResponse]
    def prune_packages(prune_packages, opts = {})
      data, _status_code, _headers = prune_packages_with_http_info(prune_packages, opts)
      data
    end

    # Trigger an asynchronous old-Package-prune operation.
    # @param prune_packages [PrunePackages] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(TaskGroupOperationResponse, Integer, Hash)>] TaskGroupOperationResponse data, response status code and response headers
    def prune_packages_with_http_info(prune_packages, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RpmPruneApi.prune_packages ...'
      end
      # verify the required parameter 'prune_packages' is set
      if @api_client.config.client_side_validation && prune_packages.nil?
        fail ArgumentError, "Missing the required parameter 'prune_packages' when calling RpmPruneApi.prune_packages"
      end
      # resource path
      local_var_path = '/pulp/api/v3/rpm/prune/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']
      # HTTP header 'Content-Type'
      content_type = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])
      if !content_type.nil?
          header_params['Content-Type'] = content_type
      end

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(prune_packages)

      # return_type
      return_type = opts[:debug_return_type] || 'TaskGroupOperationResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"RpmPruneApi.prune_packages",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RpmPruneApi#prune_packages\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
