=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
Generator version: 7.10.0

=end

require 'date'
require 'time'

module PulpRpmClient
  # DistributionTree serializer.
  class RpmDistributionTreeResponse
    attr_accessor :pulp_href

    # The Pulp Resource Name (PRN).
    attr_accessor :prn

    # Header Version.
    attr_accessor :header_version

    # Release name.
    attr_accessor :release_name

    # Release short name.
    attr_accessor :release_short

    # Release version.
    attr_accessor :release_version

    # Typically False for an operating system, True otherwise.
    attr_accessor :release_is_layered

    # Base Product name.
    attr_accessor :base_product_name

    # Base Product short name.
    attr_accessor :base_product_short

    # Base Product version.
    attr_accessor :base_product_version

    # Tree architecturerch.
    attr_accessor :arch

    # Tree build time timestamp.
    attr_accessor :build_timestamp

    # Relative path to Anaconda instimage.
    attr_accessor :instimage

    # Relative path to Anaconda stage2 image.
    attr_accessor :mainimage

    # Disc number.
    attr_accessor :discnum

    # Number of discs in media set.
    attr_accessor :totaldiscs

    attr_accessor :addons

    attr_accessor :checksums

    attr_accessor :images

    attr_accessor :variants

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'pulp_href' => :'pulp_href',
        :'prn' => :'prn',
        :'header_version' => :'header_version',
        :'release_name' => :'release_name',
        :'release_short' => :'release_short',
        :'release_version' => :'release_version',
        :'release_is_layered' => :'release_is_layered',
        :'base_product_name' => :'base_product_name',
        :'base_product_short' => :'base_product_short',
        :'base_product_version' => :'base_product_version',
        :'arch' => :'arch',
        :'build_timestamp' => :'build_timestamp',
        :'instimage' => :'instimage',
        :'mainimage' => :'mainimage',
        :'discnum' => :'discnum',
        :'totaldiscs' => :'totaldiscs',
        :'addons' => :'addons',
        :'checksums' => :'checksums',
        :'images' => :'images',
        :'variants' => :'variants'
      }
    end

    # Returns all the JSON keys this model knows about
    def self.acceptable_attributes
      attribute_map.values
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'pulp_href' => :'String',
        :'prn' => :'String',
        :'header_version' => :'String',
        :'release_name' => :'String',
        :'release_short' => :'String',
        :'release_version' => :'String',
        :'release_is_layered' => :'Boolean',
        :'base_product_name' => :'String',
        :'base_product_short' => :'String',
        :'base_product_version' => :'String',
        :'arch' => :'String',
        :'build_timestamp' => :'Float',
        :'instimage' => :'String',
        :'mainimage' => :'String',
        :'discnum' => :'Integer',
        :'totaldiscs' => :'Integer',
        :'addons' => :'Array<AddonResponse>',
        :'checksums' => :'Array<ChecksumResponse>',
        :'images' => :'Array<ImageResponse>',
        :'variants' => :'Array<VariantResponse>'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
        :'base_product_name',
        :'base_product_short',
        :'base_product_version',
        :'instimage',
        :'mainimage',
        :'discnum',
        :'totaldiscs',
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `PulpRpmClient::RpmDistributionTreeResponse` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `PulpRpmClient::RpmDistributionTreeResponse`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'pulp_href')
        self.pulp_href = attributes[:'pulp_href']
      end

      if attributes.key?(:'prn')
        self.prn = attributes[:'prn']
      end

      if attributes.key?(:'header_version')
        self.header_version = attributes[:'header_version']
      else
        self.header_version = nil
      end

      if attributes.key?(:'release_name')
        self.release_name = attributes[:'release_name']
      else
        self.release_name = nil
      end

      if attributes.key?(:'release_short')
        self.release_short = attributes[:'release_short']
      else
        self.release_short = nil
      end

      if attributes.key?(:'release_version')
        self.release_version = attributes[:'release_version']
      else
        self.release_version = nil
      end

      if attributes.key?(:'release_is_layered')
        self.release_is_layered = attributes[:'release_is_layered']
      else
        self.release_is_layered = nil
      end

      if attributes.key?(:'base_product_name')
        self.base_product_name = attributes[:'base_product_name']
      else
        self.base_product_name = nil
      end

      if attributes.key?(:'base_product_short')
        self.base_product_short = attributes[:'base_product_short']
      else
        self.base_product_short = nil
      end

      if attributes.key?(:'base_product_version')
        self.base_product_version = attributes[:'base_product_version']
      else
        self.base_product_version = nil
      end

      if attributes.key?(:'arch')
        self.arch = attributes[:'arch']
      else
        self.arch = nil
      end

      if attributes.key?(:'build_timestamp')
        self.build_timestamp = attributes[:'build_timestamp']
      else
        self.build_timestamp = nil
      end

      if attributes.key?(:'instimage')
        self.instimage = attributes[:'instimage']
      else
        self.instimage = nil
      end

      if attributes.key?(:'mainimage')
        self.mainimage = attributes[:'mainimage']
      else
        self.mainimage = nil
      end

      if attributes.key?(:'discnum')
        self.discnum = attributes[:'discnum']
      else
        self.discnum = nil
      end

      if attributes.key?(:'totaldiscs')
        self.totaldiscs = attributes[:'totaldiscs']
      else
        self.totaldiscs = nil
      end

      if attributes.key?(:'addons')
        if (value = attributes[:'addons']).is_a?(Array)
          self.addons = value
        end
      else
        self.addons = nil
      end

      if attributes.key?(:'checksums')
        if (value = attributes[:'checksums']).is_a?(Array)
          self.checksums = value
        end
      else
        self.checksums = nil
      end

      if attributes.key?(:'images')
        if (value = attributes[:'images']).is_a?(Array)
          self.images = value
        end
      else
        self.images = nil
      end

      if attributes.key?(:'variants')
        if (value = attributes[:'variants']).is_a?(Array)
          self.variants = value
        end
      else
        self.variants = nil
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      warn '[DEPRECATED] the `list_invalid_properties` method is obsolete'
      invalid_properties = Array.new
      if @header_version.nil?
        invalid_properties.push('invalid value for "header_version", header_version cannot be nil.')
      end

      if @release_name.nil?
        invalid_properties.push('invalid value for "release_name", release_name cannot be nil.')
      end

      if @release_short.nil?
        invalid_properties.push('invalid value for "release_short", release_short cannot be nil.')
      end

      if @release_version.nil?
        invalid_properties.push('invalid value for "release_version", release_version cannot be nil.')
      end

      if @release_is_layered.nil?
        invalid_properties.push('invalid value for "release_is_layered", release_is_layered cannot be nil.')
      end

      if @arch.nil?
        invalid_properties.push('invalid value for "arch", arch cannot be nil.')
      end

      if @build_timestamp.nil?
        invalid_properties.push('invalid value for "build_timestamp", build_timestamp cannot be nil.')
      end

      if @addons.nil?
        invalid_properties.push('invalid value for "addons", addons cannot be nil.')
      end

      if @checksums.nil?
        invalid_properties.push('invalid value for "checksums", checksums cannot be nil.')
      end

      if @images.nil?
        invalid_properties.push('invalid value for "images", images cannot be nil.')
      end

      if @variants.nil?
        invalid_properties.push('invalid value for "variants", variants cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      warn '[DEPRECATED] the `valid?` method is obsolete'
      return false if @header_version.nil?
      return false if @release_name.nil?
      return false if @release_short.nil?
      return false if @release_version.nil?
      return false if @release_is_layered.nil?
      return false if @arch.nil?
      return false if @build_timestamp.nil?
      return false if @addons.nil?
      return false if @checksums.nil?
      return false if @images.nil?
      return false if @variants.nil?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          pulp_href == o.pulp_href &&
          prn == o.prn &&
          header_version == o.header_version &&
          release_name == o.release_name &&
          release_short == o.release_short &&
          release_version == o.release_version &&
          release_is_layered == o.release_is_layered &&
          base_product_name == o.base_product_name &&
          base_product_short == o.base_product_short &&
          base_product_version == o.base_product_version &&
          arch == o.arch &&
          build_timestamp == o.build_timestamp &&
          instimage == o.instimage &&
          mainimage == o.mainimage &&
          discnum == o.discnum &&
          totaldiscs == o.totaldiscs &&
          addons == o.addons &&
          checksums == o.checksums &&
          images == o.images &&
          variants == o.variants
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [pulp_href, prn, header_version, release_name, release_short, release_version, release_is_layered, base_product_name, base_product_short, base_product_version, arch, build_timestamp, instimage, mainimage, discnum, totaldiscs, addons, checksums, images, variants].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      attributes = attributes.transform_keys(&:to_sym)
      transformed_hash = {}
      openapi_types.each_pair do |key, type|
        if attributes.key?(attribute_map[key]) && attributes[attribute_map[key]].nil?
          transformed_hash["#{key}"] = nil
        elsif type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[attribute_map[key]].is_a?(Array)
            transformed_hash["#{key}"] = attributes[attribute_map[key]].map { |v| _deserialize($1, v) }
          end
        elsif !attributes[attribute_map[key]].nil?
          transformed_hash["#{key}"] = _deserialize(type, attributes[attribute_map[key]])
        end
      end
      new(transformed_hash)
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def self._deserialize(type, value)
      case type.to_sym
      when :Time
        Time.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        # models (e.g. Pet) or oneOf
        klass = PulpRpmClient.const_get(type)
        klass.respond_to?(:openapi_any_of) || klass.respond_to?(:openapi_one_of) ? klass.build(value) : klass.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
