=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
Generator version: 7.10.0

=end

require 'date'
require 'time'

module PulpRpmClient
  # Modulemd serializer.
  class RpmModulemd
    # A URI of a repository the new content unit should be associated with.
    attr_accessor :repository

    # A dictionary of arbitrary key/value pairs used to describe a specific Content instance.
    attr_accessor :pulp_labels

    # Modulemd name.
    attr_accessor :name

    # Stream name.
    attr_accessor :stream

    # Modulemd version.
    attr_accessor :version

    # Modulemd static-context flag.
    attr_accessor :static_context

    # Modulemd context.
    attr_accessor :context

    # Modulemd architecture.
    attr_accessor :arch

    # Modulemd artifacts.
    attr_accessor :artifacts

    # Modulemd dependencies.
    attr_accessor :dependencies

    # Modulemd artifacts' packages.
    attr_accessor :packages

    # Modulemd snippet
    attr_accessor :snippet

    # Modulemd profiles.
    attr_accessor :profiles

    # Description of module.
    attr_accessor :description

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'repository' => :'repository',
        :'pulp_labels' => :'pulp_labels',
        :'name' => :'name',
        :'stream' => :'stream',
        :'version' => :'version',
        :'static_context' => :'static_context',
        :'context' => :'context',
        :'arch' => :'arch',
        :'artifacts' => :'artifacts',
        :'dependencies' => :'dependencies',
        :'packages' => :'packages',
        :'snippet' => :'snippet',
        :'profiles' => :'profiles',
        :'description' => :'description'
      }
    end

    # Returns all the JSON keys this model knows about
    def self.acceptable_attributes
      attribute_map.values
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'repository' => :'String',
        :'pulp_labels' => :'Hash<String, String>',
        :'name' => :'String',
        :'stream' => :'String',
        :'version' => :'String',
        :'static_context' => :'Boolean',
        :'context' => :'String',
        :'arch' => :'String',
        :'artifacts' => :'Object',
        :'dependencies' => :'Object',
        :'packages' => :'Array<String>',
        :'snippet' => :'String',
        :'profiles' => :'Object',
        :'description' => :'String'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
        :'artifacts',
        :'dependencies',
        :'profiles',
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `PulpRpmClient::RpmModulemd` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `PulpRpmClient::RpmModulemd`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'repository')
        self.repository = attributes[:'repository']
      end

      if attributes.key?(:'pulp_labels')
        if (value = attributes[:'pulp_labels']).is_a?(Hash)
          self.pulp_labels = value
        end
      end

      if attributes.key?(:'name')
        self.name = attributes[:'name']
      else
        self.name = nil
      end

      if attributes.key?(:'stream')
        self.stream = attributes[:'stream']
      else
        self.stream = nil
      end

      if attributes.key?(:'version')
        self.version = attributes[:'version']
      else
        self.version = nil
      end

      if attributes.key?(:'static_context')
        self.static_context = attributes[:'static_context']
      end

      if attributes.key?(:'context')
        self.context = attributes[:'context']
      else
        self.context = nil
      end

      if attributes.key?(:'arch')
        self.arch = attributes[:'arch']
      else
        self.arch = nil
      end

      if attributes.key?(:'artifacts')
        self.artifacts = attributes[:'artifacts']
      else
        self.artifacts = nil
      end

      if attributes.key?(:'dependencies')
        self.dependencies = attributes[:'dependencies']
      else
        self.dependencies = nil
      end

      if attributes.key?(:'packages')
        if (value = attributes[:'packages']).is_a?(Array)
          self.packages = value
        end
      end

      if attributes.key?(:'snippet')
        self.snippet = attributes[:'snippet']
      else
        self.snippet = nil
      end

      if attributes.key?(:'profiles')
        self.profiles = attributes[:'profiles']
      else
        self.profiles = nil
      end

      if attributes.key?(:'description')
        self.description = attributes[:'description']
      else
        self.description = nil
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      warn '[DEPRECATED] the `list_invalid_properties` method is obsolete'
      invalid_properties = Array.new
      if @name.nil?
        invalid_properties.push('invalid value for "name", name cannot be nil.')
      end

      if @name.to_s.length < 1
        invalid_properties.push('invalid value for "name", the character length must be great than or equal to 1.')
      end

      if @stream.nil?
        invalid_properties.push('invalid value for "stream", stream cannot be nil.')
      end

      if @stream.to_s.length < 1
        invalid_properties.push('invalid value for "stream", the character length must be great than or equal to 1.')
      end

      if @version.nil?
        invalid_properties.push('invalid value for "version", version cannot be nil.')
      end

      if @version.to_s.length < 1
        invalid_properties.push('invalid value for "version", the character length must be great than or equal to 1.')
      end

      if @context.nil?
        invalid_properties.push('invalid value for "context", context cannot be nil.')
      end

      if @context.to_s.length < 1
        invalid_properties.push('invalid value for "context", the character length must be great than or equal to 1.')
      end

      if @arch.nil?
        invalid_properties.push('invalid value for "arch", arch cannot be nil.')
      end

      if @arch.to_s.length < 1
        invalid_properties.push('invalid value for "arch", the character length must be great than or equal to 1.')
      end

      if @snippet.nil?
        invalid_properties.push('invalid value for "snippet", snippet cannot be nil.')
      end

      if @snippet.to_s.length < 1
        invalid_properties.push('invalid value for "snippet", the character length must be great than or equal to 1.')
      end

      if @description.nil?
        invalid_properties.push('invalid value for "description", description cannot be nil.')
      end

      if @description.to_s.length < 1
        invalid_properties.push('invalid value for "description", the character length must be great than or equal to 1.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      warn '[DEPRECATED] the `valid?` method is obsolete'
      return false if @name.nil?
      return false if @name.to_s.length < 1
      return false if @stream.nil?
      return false if @stream.to_s.length < 1
      return false if @version.nil?
      return false if @version.to_s.length < 1
      return false if @context.nil?
      return false if @context.to_s.length < 1
      return false if @arch.nil?
      return false if @arch.to_s.length < 1
      return false if @snippet.nil?
      return false if @snippet.to_s.length < 1
      return false if @description.nil?
      return false if @description.to_s.length < 1
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] name Value to be assigned
    def name=(name)
      if name.nil?
        fail ArgumentError, 'name cannot be nil'
      end

      if name.to_s.length < 1
        fail ArgumentError, 'invalid value for "name", the character length must be great than or equal to 1.'
      end

      @name = name
    end

    # Custom attribute writer method with validation
    # @param [Object] stream Value to be assigned
    def stream=(stream)
      if stream.nil?
        fail ArgumentError, 'stream cannot be nil'
      end

      if stream.to_s.length < 1
        fail ArgumentError, 'invalid value for "stream", the character length must be great than or equal to 1.'
      end

      @stream = stream
    end

    # Custom attribute writer method with validation
    # @param [Object] version Value to be assigned
    def version=(version)
      if version.nil?
        fail ArgumentError, 'version cannot be nil'
      end

      if version.to_s.length < 1
        fail ArgumentError, 'invalid value for "version", the character length must be great than or equal to 1.'
      end

      @version = version
    end

    # Custom attribute writer method with validation
    # @param [Object] context Value to be assigned
    def context=(context)
      if context.nil?
        fail ArgumentError, 'context cannot be nil'
      end

      if context.to_s.length < 1
        fail ArgumentError, 'invalid value for "context", the character length must be great than or equal to 1.'
      end

      @context = context
    end

    # Custom attribute writer method with validation
    # @param [Object] arch Value to be assigned
    def arch=(arch)
      if arch.nil?
        fail ArgumentError, 'arch cannot be nil'
      end

      if arch.to_s.length < 1
        fail ArgumentError, 'invalid value for "arch", the character length must be great than or equal to 1.'
      end

      @arch = arch
    end

    # Custom attribute writer method with validation
    # @param [Object] snippet Value to be assigned
    def snippet=(snippet)
      if snippet.nil?
        fail ArgumentError, 'snippet cannot be nil'
      end

      if snippet.to_s.length < 1
        fail ArgumentError, 'invalid value for "snippet", the character length must be great than or equal to 1.'
      end

      @snippet = snippet
    end

    # Custom attribute writer method with validation
    # @param [Object] description Value to be assigned
    def description=(description)
      if description.nil?
        fail ArgumentError, 'description cannot be nil'
      end

      if description.to_s.length < 1
        fail ArgumentError, 'invalid value for "description", the character length must be great than or equal to 1.'
      end

      @description = description
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          repository == o.repository &&
          pulp_labels == o.pulp_labels &&
          name == o.name &&
          stream == o.stream &&
          version == o.version &&
          static_context == o.static_context &&
          context == o.context &&
          arch == o.arch &&
          artifacts == o.artifacts &&
          dependencies == o.dependencies &&
          packages == o.packages &&
          snippet == o.snippet &&
          profiles == o.profiles &&
          description == o.description
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [repository, pulp_labels, name, stream, version, static_context, context, arch, artifacts, dependencies, packages, snippet, profiles, description].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      attributes = attributes.transform_keys(&:to_sym)
      transformed_hash = {}
      openapi_types.each_pair do |key, type|
        if attributes.key?(attribute_map[key]) && attributes[attribute_map[key]].nil?
          transformed_hash["#{key}"] = nil
        elsif type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[attribute_map[key]].is_a?(Array)
            transformed_hash["#{key}"] = attributes[attribute_map[key]].map { |v| _deserialize($1, v) }
          end
        elsif !attributes[attribute_map[key]].nil?
          transformed_hash["#{key}"] = _deserialize(type, attributes[attribute_map[key]])
        end
      end
      new(transformed_hash)
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def self._deserialize(type, value)
      case type.to_sym
      when :Time
        Time.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        # models (e.g. Pet) or oneOf
        klass = PulpRpmClient.const_get(type)
        klass.respond_to?(:openapi_any_of) || klass.respond_to?(:openapi_one_of) ? klass.build(value) : klass.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
