=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
Generator version: 7.10.0

=end

require 'date'
require 'time'

module PulpRpmClient
  # ModulemdObsolete serializer.
  class RpmModulemdObsolete
    # A URI of a repository the new content unit should be associated with.
    attr_accessor :repository

    # A dictionary of arbitrary key/value pairs used to describe a specific Content instance.
    attr_accessor :pulp_labels

    # Obsolete modified time.
    attr_accessor :modified

    # Modulemd name.
    attr_accessor :module_name

    # Modulemd's stream.
    attr_accessor :module_stream

    # Obsolete description.
    attr_accessor :message

    # Reset previous obsoletes.
    attr_accessor :override_previous

    # Modulemd's context.
    attr_accessor :module_context

    # End of Life date.
    attr_accessor :eol_date

    # Obsolete by module name.
    attr_accessor :obsoleted_by_module_name

    # Obsolete by module stream.
    attr_accessor :obsoleted_by_module_stream

    # Module Obsolete snippet.
    attr_accessor :snippet

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'repository' => :'repository',
        :'pulp_labels' => :'pulp_labels',
        :'modified' => :'modified',
        :'module_name' => :'module_name',
        :'module_stream' => :'module_stream',
        :'message' => :'message',
        :'override_previous' => :'override_previous',
        :'module_context' => :'module_context',
        :'eol_date' => :'eol_date',
        :'obsoleted_by_module_name' => :'obsoleted_by_module_name',
        :'obsoleted_by_module_stream' => :'obsoleted_by_module_stream',
        :'snippet' => :'snippet'
      }
    end

    # Returns all the JSON keys this model knows about
    def self.acceptable_attributes
      attribute_map.values
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'repository' => :'String',
        :'pulp_labels' => :'Hash<String, String>',
        :'modified' => :'String',
        :'module_name' => :'String',
        :'module_stream' => :'String',
        :'message' => :'String',
        :'override_previous' => :'String',
        :'module_context' => :'String',
        :'eol_date' => :'String',
        :'obsoleted_by_module_name' => :'String',
        :'obsoleted_by_module_stream' => :'String',
        :'snippet' => :'String'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
        :'override_previous',
        :'module_context',
        :'eol_date',
        :'obsoleted_by_module_name',
        :'obsoleted_by_module_stream',
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `PulpRpmClient::RpmModulemdObsolete` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `PulpRpmClient::RpmModulemdObsolete`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'repository')
        self.repository = attributes[:'repository']
      end

      if attributes.key?(:'pulp_labels')
        if (value = attributes[:'pulp_labels']).is_a?(Hash)
          self.pulp_labels = value
        end
      end

      if attributes.key?(:'modified')
        self.modified = attributes[:'modified']
      else
        self.modified = nil
      end

      if attributes.key?(:'module_name')
        self.module_name = attributes[:'module_name']
      else
        self.module_name = nil
      end

      if attributes.key?(:'module_stream')
        self.module_stream = attributes[:'module_stream']
      else
        self.module_stream = nil
      end

      if attributes.key?(:'message')
        self.message = attributes[:'message']
      else
        self.message = nil
      end

      if attributes.key?(:'override_previous')
        self.override_previous = attributes[:'override_previous']
      else
        self.override_previous = nil
      end

      if attributes.key?(:'module_context')
        self.module_context = attributes[:'module_context']
      else
        self.module_context = nil
      end

      if attributes.key?(:'eol_date')
        self.eol_date = attributes[:'eol_date']
      else
        self.eol_date = nil
      end

      if attributes.key?(:'obsoleted_by_module_name')
        self.obsoleted_by_module_name = attributes[:'obsoleted_by_module_name']
      else
        self.obsoleted_by_module_name = nil
      end

      if attributes.key?(:'obsoleted_by_module_stream')
        self.obsoleted_by_module_stream = attributes[:'obsoleted_by_module_stream']
      else
        self.obsoleted_by_module_stream = nil
      end

      if attributes.key?(:'snippet')
        self.snippet = attributes[:'snippet']
      else
        self.snippet = nil
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      warn '[DEPRECATED] the `list_invalid_properties` method is obsolete'
      invalid_properties = Array.new
      if @modified.nil?
        invalid_properties.push('invalid value for "modified", modified cannot be nil.')
      end

      if @modified.to_s.length < 1
        invalid_properties.push('invalid value for "modified", the character length must be great than or equal to 1.')
      end

      if @module_name.nil?
        invalid_properties.push('invalid value for "module_name", module_name cannot be nil.')
      end

      if @module_name.to_s.length < 1
        invalid_properties.push('invalid value for "module_name", the character length must be great than or equal to 1.')
      end

      if @module_stream.nil?
        invalid_properties.push('invalid value for "module_stream", module_stream cannot be nil.')
      end

      if @module_stream.to_s.length < 1
        invalid_properties.push('invalid value for "module_stream", the character length must be great than or equal to 1.')
      end

      if @message.nil?
        invalid_properties.push('invalid value for "message", message cannot be nil.')
      end

      if @message.to_s.length < 1
        invalid_properties.push('invalid value for "message", the character length must be great than or equal to 1.')
      end

      if @override_previous.to_s.length < 1
        invalid_properties.push('invalid value for "override_previous", the character length must be great than or equal to 1.')
      end

      if @module_context.to_s.length < 1
        invalid_properties.push('invalid value for "module_context", the character length must be great than or equal to 1.')
      end

      if @eol_date.to_s.length < 1
        invalid_properties.push('invalid value for "eol_date", the character length must be great than or equal to 1.')
      end

      if @obsoleted_by_module_name.to_s.length < 1
        invalid_properties.push('invalid value for "obsoleted_by_module_name", the character length must be great than or equal to 1.')
      end

      if @obsoleted_by_module_stream.to_s.length < 1
        invalid_properties.push('invalid value for "obsoleted_by_module_stream", the character length must be great than or equal to 1.')
      end

      if @snippet.nil?
        invalid_properties.push('invalid value for "snippet", snippet cannot be nil.')
      end

      if @snippet.to_s.length < 1
        invalid_properties.push('invalid value for "snippet", the character length must be great than or equal to 1.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      warn '[DEPRECATED] the `valid?` method is obsolete'
      return false if @modified.nil?
      return false if @modified.to_s.length < 1
      return false if @module_name.nil?
      return false if @module_name.to_s.length < 1
      return false if @module_stream.nil?
      return false if @module_stream.to_s.length < 1
      return false if @message.nil?
      return false if @message.to_s.length < 1
      return false if @override_previous.to_s.length < 1
      return false if @module_context.to_s.length < 1
      return false if @eol_date.to_s.length < 1
      return false if @obsoleted_by_module_name.to_s.length < 1
      return false if @obsoleted_by_module_stream.to_s.length < 1
      return false if @snippet.nil?
      return false if @snippet.to_s.length < 1
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] modified Value to be assigned
    def modified=(modified)
      if modified.nil?
        fail ArgumentError, 'modified cannot be nil'
      end

      if modified.to_s.length < 1
        fail ArgumentError, 'invalid value for "modified", the character length must be great than or equal to 1.'
      end

      @modified = modified
    end

    # Custom attribute writer method with validation
    # @param [Object] module_name Value to be assigned
    def module_name=(module_name)
      if module_name.nil?
        fail ArgumentError, 'module_name cannot be nil'
      end

      if module_name.to_s.length < 1
        fail ArgumentError, 'invalid value for "module_name", the character length must be great than or equal to 1.'
      end

      @module_name = module_name
    end

    # Custom attribute writer method with validation
    # @param [Object] module_stream Value to be assigned
    def module_stream=(module_stream)
      if module_stream.nil?
        fail ArgumentError, 'module_stream cannot be nil'
      end

      if module_stream.to_s.length < 1
        fail ArgumentError, 'invalid value for "module_stream", the character length must be great than or equal to 1.'
      end

      @module_stream = module_stream
    end

    # Custom attribute writer method with validation
    # @param [Object] message Value to be assigned
    def message=(message)
      if message.nil?
        fail ArgumentError, 'message cannot be nil'
      end

      if message.to_s.length < 1
        fail ArgumentError, 'invalid value for "message", the character length must be great than or equal to 1.'
      end

      @message = message
    end

    # Custom attribute writer method with validation
    # @param [Object] override_previous Value to be assigned
    def override_previous=(override_previous)
      if !override_previous.nil? && override_previous.to_s.length < 1
        fail ArgumentError, 'invalid value for "override_previous", the character length must be great than or equal to 1.'
      end

      @override_previous = override_previous
    end

    # Custom attribute writer method with validation
    # @param [Object] module_context Value to be assigned
    def module_context=(module_context)
      if !module_context.nil? && module_context.to_s.length < 1
        fail ArgumentError, 'invalid value for "module_context", the character length must be great than or equal to 1.'
      end

      @module_context = module_context
    end

    # Custom attribute writer method with validation
    # @param [Object] eol_date Value to be assigned
    def eol_date=(eol_date)
      if !eol_date.nil? && eol_date.to_s.length < 1
        fail ArgumentError, 'invalid value for "eol_date", the character length must be great than or equal to 1.'
      end

      @eol_date = eol_date
    end

    # Custom attribute writer method with validation
    # @param [Object] obsoleted_by_module_name Value to be assigned
    def obsoleted_by_module_name=(obsoleted_by_module_name)
      if !obsoleted_by_module_name.nil? && obsoleted_by_module_name.to_s.length < 1
        fail ArgumentError, 'invalid value for "obsoleted_by_module_name", the character length must be great than or equal to 1.'
      end

      @obsoleted_by_module_name = obsoleted_by_module_name
    end

    # Custom attribute writer method with validation
    # @param [Object] obsoleted_by_module_stream Value to be assigned
    def obsoleted_by_module_stream=(obsoleted_by_module_stream)
      if !obsoleted_by_module_stream.nil? && obsoleted_by_module_stream.to_s.length < 1
        fail ArgumentError, 'invalid value for "obsoleted_by_module_stream", the character length must be great than or equal to 1.'
      end

      @obsoleted_by_module_stream = obsoleted_by_module_stream
    end

    # Custom attribute writer method with validation
    # @param [Object] snippet Value to be assigned
    def snippet=(snippet)
      if snippet.nil?
        fail ArgumentError, 'snippet cannot be nil'
      end

      if snippet.to_s.length < 1
        fail ArgumentError, 'invalid value for "snippet", the character length must be great than or equal to 1.'
      end

      @snippet = snippet
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          repository == o.repository &&
          pulp_labels == o.pulp_labels &&
          modified == o.modified &&
          module_name == o.module_name &&
          module_stream == o.module_stream &&
          message == o.message &&
          override_previous == o.override_previous &&
          module_context == o.module_context &&
          eol_date == o.eol_date &&
          obsoleted_by_module_name == o.obsoleted_by_module_name &&
          obsoleted_by_module_stream == o.obsoleted_by_module_stream &&
          snippet == o.snippet
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [repository, pulp_labels, modified, module_name, module_stream, message, override_previous, module_context, eol_date, obsoleted_by_module_name, obsoleted_by_module_stream, snippet].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      attributes = attributes.transform_keys(&:to_sym)
      transformed_hash = {}
      openapi_types.each_pair do |key, type|
        if attributes.key?(attribute_map[key]) && attributes[attribute_map[key]].nil?
          transformed_hash["#{key}"] = nil
        elsif type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[attribute_map[key]].is_a?(Array)
            transformed_hash["#{key}"] = attributes[attribute_map[key]].map { |v| _deserialize($1, v) }
          end
        elsif !attributes[attribute_map[key]].nil?
          transformed_hash["#{key}"] = _deserialize(type, attributes[attribute_map[key]])
        end
      end
      new(transformed_hash)
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def self._deserialize(type, value)
      case type.to_sym
      when :Time
        Time.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        # models (e.g. Pet) or oneOf
        klass = PulpRpmClient.const_get(type)
        klass.respond_to?(:openapi_any_of) || klass.respond_to?(:openapi_one_of) ? klass.build(value) : klass.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
