=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
Generator version: 7.10.0

=end

require 'date'
require 'time'

module PulpRpmClient
  # PackageEnvironment serializer.
  class RpmPackageEnvironmentResponse
    attr_accessor :pulp_href

    # The Pulp Resource Name (PRN).
    attr_accessor :prn

    # Timestamp of creation.
    attr_accessor :pulp_created

    # Timestamp of the last time this resource was updated. Note: for immutable resources - like content, repository versions, and publication - pulp_created and pulp_last_updated dates will be the same.
    attr_accessor :pulp_last_updated

    # A dictionary of arbitrary key/value pairs used to describe a specific Content instance.
    attr_accessor :pulp_labels

    # Environment id.
    attr_accessor :id

    # Environment name.
    attr_accessor :name

    # Environment description.
    attr_accessor :description

    # Environment display order.
    attr_accessor :display_order

    # Environment group list.
    attr_accessor :group_ids

    # Environment option ids
    attr_accessor :option_ids

    # Environment description by language.
    attr_accessor :desc_by_lang

    # Environment name by language.
    attr_accessor :name_by_lang

    # Environment digest.
    attr_accessor :digest

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'pulp_href' => :'pulp_href',
        :'prn' => :'prn',
        :'pulp_created' => :'pulp_created',
        :'pulp_last_updated' => :'pulp_last_updated',
        :'pulp_labels' => :'pulp_labels',
        :'id' => :'id',
        :'name' => :'name',
        :'description' => :'description',
        :'display_order' => :'display_order',
        :'group_ids' => :'group_ids',
        :'option_ids' => :'option_ids',
        :'desc_by_lang' => :'desc_by_lang',
        :'name_by_lang' => :'name_by_lang',
        :'digest' => :'digest'
      }
    end

    # Returns all the JSON keys this model knows about
    def self.acceptable_attributes
      attribute_map.values
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'pulp_href' => :'String',
        :'prn' => :'String',
        :'pulp_created' => :'Time',
        :'pulp_last_updated' => :'Time',
        :'pulp_labels' => :'Hash<String, String>',
        :'id' => :'String',
        :'name' => :'String',
        :'description' => :'String',
        :'display_order' => :'Integer',
        :'group_ids' => :'Object',
        :'option_ids' => :'Object',
        :'desc_by_lang' => :'Object',
        :'name_by_lang' => :'Object',
        :'digest' => :'String'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
        :'display_order',
        :'group_ids',
        :'option_ids',
        :'desc_by_lang',
        :'name_by_lang',
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `PulpRpmClient::RpmPackageEnvironmentResponse` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `PulpRpmClient::RpmPackageEnvironmentResponse`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'pulp_href')
        self.pulp_href = attributes[:'pulp_href']
      end

      if attributes.key?(:'prn')
        self.prn = attributes[:'prn']
      end

      if attributes.key?(:'pulp_created')
        self.pulp_created = attributes[:'pulp_created']
      end

      if attributes.key?(:'pulp_last_updated')
        self.pulp_last_updated = attributes[:'pulp_last_updated']
      end

      if attributes.key?(:'pulp_labels')
        if (value = attributes[:'pulp_labels']).is_a?(Hash)
          self.pulp_labels = value
        end
      end

      if attributes.key?(:'id')
        self.id = attributes[:'id']
      else
        self.id = nil
      end

      if attributes.key?(:'name')
        self.name = attributes[:'name']
      else
        self.name = nil
      end

      if attributes.key?(:'description')
        self.description = attributes[:'description']
      else
        self.description = nil
      end

      if attributes.key?(:'display_order')
        self.display_order = attributes[:'display_order']
      else
        self.display_order = nil
      end

      if attributes.key?(:'group_ids')
        self.group_ids = attributes[:'group_ids']
      else
        self.group_ids = nil
      end

      if attributes.key?(:'option_ids')
        self.option_ids = attributes[:'option_ids']
      else
        self.option_ids = nil
      end

      if attributes.key?(:'desc_by_lang')
        self.desc_by_lang = attributes[:'desc_by_lang']
      else
        self.desc_by_lang = nil
      end

      if attributes.key?(:'name_by_lang')
        self.name_by_lang = attributes[:'name_by_lang']
      else
        self.name_by_lang = nil
      end

      if attributes.key?(:'digest')
        self.digest = attributes[:'digest']
      else
        self.digest = nil
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      warn '[DEPRECATED] the `list_invalid_properties` method is obsolete'
      invalid_properties = Array.new
      if @id.nil?
        invalid_properties.push('invalid value for "id", id cannot be nil.')
      end

      if @name.nil?
        invalid_properties.push('invalid value for "name", name cannot be nil.')
      end

      if @description.nil?
        invalid_properties.push('invalid value for "description", description cannot be nil.')
      end

      if @digest.nil?
        invalid_properties.push('invalid value for "digest", digest cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      warn '[DEPRECATED] the `valid?` method is obsolete'
      return false if @id.nil?
      return false if @name.nil?
      return false if @description.nil?
      return false if @digest.nil?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          pulp_href == o.pulp_href &&
          prn == o.prn &&
          pulp_created == o.pulp_created &&
          pulp_last_updated == o.pulp_last_updated &&
          pulp_labels == o.pulp_labels &&
          id == o.id &&
          name == o.name &&
          description == o.description &&
          display_order == o.display_order &&
          group_ids == o.group_ids &&
          option_ids == o.option_ids &&
          desc_by_lang == o.desc_by_lang &&
          name_by_lang == o.name_by_lang &&
          digest == o.digest
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [pulp_href, prn, pulp_created, pulp_last_updated, pulp_labels, id, name, description, display_order, group_ids, option_ids, desc_by_lang, name_by_lang, digest].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      attributes = attributes.transform_keys(&:to_sym)
      transformed_hash = {}
      openapi_types.each_pair do |key, type|
        if attributes.key?(attribute_map[key]) && attributes[attribute_map[key]].nil?
          transformed_hash["#{key}"] = nil
        elsif type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[attribute_map[key]].is_a?(Array)
            transformed_hash["#{key}"] = attributes[attribute_map[key]].map { |v| _deserialize($1, v) }
          end
        elsif !attributes[attribute_map[key]].nil?
          transformed_hash["#{key}"] = _deserialize(type, attributes[attribute_map[key]])
        end
      end
      new(transformed_hash)
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def self._deserialize(type, value)
      case type.to_sym
      when :Time
        Time.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        # models (e.g. Pet) or oneOf
        klass = PulpRpmClient.const_get(type)
        klass.respond_to?(:openapi_any_of) || klass.respond_to?(:openapi_one_of) ? klass.build(value) : klass.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
