=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
Generator version: 7.10.0

=end

require 'date'
require 'time'

module PulpRpmClient
  # Serializer for Rpm Repositories.
  class RpmRpmRepositoryResponse
    attr_accessor :pulp_href

    # The Pulp Resource Name (PRN).
    attr_accessor :prn

    # Timestamp of creation.
    attr_accessor :pulp_created

    # Timestamp of the last time this resource was updated. Note: for immutable resources - like content, repository versions, and publication - pulp_created and pulp_last_updated dates will be the same.
    attr_accessor :pulp_last_updated

    attr_accessor :versions_href

    attr_accessor :pulp_labels

    attr_accessor :latest_version_href

    # A unique name for this repository.
    attr_accessor :name

    # An optional description.
    attr_accessor :description

    # Retain X versions of the repository. Default is null which retains all versions.
    attr_accessor :retain_repo_versions

    # An optional remote to use by default when syncing.
    attr_accessor :remote

    # Whether to automatically create publications for new repository versions, and update any distributions pointing to this repository.
    attr_accessor :autopublish

    # A reference to an associated signing service.
    attr_accessor :metadata_signing_service

    # A reference to an associated package signing service.
    attr_accessor :package_signing_service

    # The pubkey V4 fingerprint (160 bits) to be passed to the package signing service.The signing service will use that on signing operations related to this repository.
    attr_accessor :package_signing_fingerprint

    # The number of versions of each package to keep in the repository; older versions will be purged. The default is '0', which will disable this feature and keep all versions of each package.
    attr_accessor :retain_package_versions

    # The preferred checksum type during repo publish.  * `unknown` - unknown * `md5` - md5 * `sha1` - sha1 * `sha224` - sha224 * `sha256` - sha256 * `sha384` - sha384 * `sha512` - sha512
    attr_accessor :checksum_type

    # DEPRECATED: use CHECKSUM_TYPE instead.  * `unknown` - unknown * `md5` - md5 * `sha1` - sha1 * `sha224` - sha224 * `sha256` - sha256 * `sha384` - sha384 * `sha512` - sha512
    attr_accessor :metadata_checksum_type

    # DEPRECATED: use CHECKSUM_TYPE instead.  * `unknown` - unknown * `md5` - md5 * `sha1` - sha1 * `sha224` - sha224 * `sha256` - sha256 * `sha384` - sha384 * `sha512` - sha512
    attr_accessor :package_checksum_type

    # DEPRECATED: An option specifying whether a client should perform a GPG signature check on packages.
    attr_accessor :gpgcheck

    # DEPRECATED: An option specifying whether a client should perform a GPG signature check on the repodata.
    attr_accessor :repo_gpgcheck

    # REMOVED: An option specifying whether Pulp should generate SQLite metadata. Not operation since pulp_rpm 3.25.0 release
    attr_accessor :sqlite_metadata

    # A JSON document describing config.repo file
    attr_accessor :repo_config

    # The compression type to use for metadata files.  * `zstd` - zstd * `gz` - gz
    attr_accessor :compression_type

    # How to layout the packages within the published repository.  * `nested_alphabetically` - nested_alphabetically * `flat` - flat
    attr_accessor :layout

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'pulp_href' => :'pulp_href',
        :'prn' => :'prn',
        :'pulp_created' => :'pulp_created',
        :'pulp_last_updated' => :'pulp_last_updated',
        :'versions_href' => :'versions_href',
        :'pulp_labels' => :'pulp_labels',
        :'latest_version_href' => :'latest_version_href',
        :'name' => :'name',
        :'description' => :'description',
        :'retain_repo_versions' => :'retain_repo_versions',
        :'remote' => :'remote',
        :'autopublish' => :'autopublish',
        :'metadata_signing_service' => :'metadata_signing_service',
        :'package_signing_service' => :'package_signing_service',
        :'package_signing_fingerprint' => :'package_signing_fingerprint',
        :'retain_package_versions' => :'retain_package_versions',
        :'checksum_type' => :'checksum_type',
        :'metadata_checksum_type' => :'metadata_checksum_type',
        :'package_checksum_type' => :'package_checksum_type',
        :'gpgcheck' => :'gpgcheck',
        :'repo_gpgcheck' => :'repo_gpgcheck',
        :'sqlite_metadata' => :'sqlite_metadata',
        :'repo_config' => :'repo_config',
        :'compression_type' => :'compression_type',
        :'layout' => :'layout'
      }
    end

    # Returns all the JSON keys this model knows about
    def self.acceptable_attributes
      attribute_map.values
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'pulp_href' => :'String',
        :'prn' => :'String',
        :'pulp_created' => :'Time',
        :'pulp_last_updated' => :'Time',
        :'versions_href' => :'String',
        :'pulp_labels' => :'Hash<String, String>',
        :'latest_version_href' => :'String',
        :'name' => :'String',
        :'description' => :'String',
        :'retain_repo_versions' => :'Integer',
        :'remote' => :'String',
        :'autopublish' => :'Boolean',
        :'metadata_signing_service' => :'String',
        :'package_signing_service' => :'String',
        :'package_signing_fingerprint' => :'String',
        :'retain_package_versions' => :'Integer',
        :'checksum_type' => :'PackageChecksumTypeEnum',
        :'metadata_checksum_type' => :'PackageChecksumTypeEnum',
        :'package_checksum_type' => :'PackageChecksumTypeEnum',
        :'gpgcheck' => :'Integer',
        :'repo_gpgcheck' => :'Integer',
        :'sqlite_metadata' => :'Boolean',
        :'repo_config' => :'Object',
        :'compression_type' => :'CompressionTypeEnum',
        :'layout' => :'LayoutEnum'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
        :'description',
        :'retain_repo_versions',
        :'remote',
        :'metadata_signing_service',
        :'package_signing_service',
        :'checksum_type',
        :'metadata_checksum_type',
        :'package_checksum_type',
        :'gpgcheck',
        :'repo_gpgcheck',
        :'repo_config',
        :'compression_type',
        :'layout'
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `PulpRpmClient::RpmRpmRepositoryResponse` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `PulpRpmClient::RpmRpmRepositoryResponse`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'pulp_href')
        self.pulp_href = attributes[:'pulp_href']
      end

      if attributes.key?(:'prn')
        self.prn = attributes[:'prn']
      end

      if attributes.key?(:'pulp_created')
        self.pulp_created = attributes[:'pulp_created']
      end

      if attributes.key?(:'pulp_last_updated')
        self.pulp_last_updated = attributes[:'pulp_last_updated']
      end

      if attributes.key?(:'versions_href')
        self.versions_href = attributes[:'versions_href']
      end

      if attributes.key?(:'pulp_labels')
        if (value = attributes[:'pulp_labels']).is_a?(Hash)
          self.pulp_labels = value
        end
      end

      if attributes.key?(:'latest_version_href')
        self.latest_version_href = attributes[:'latest_version_href']
      end

      if attributes.key?(:'name')
        self.name = attributes[:'name']
      else
        self.name = nil
      end

      if attributes.key?(:'description')
        self.description = attributes[:'description']
      end

      if attributes.key?(:'retain_repo_versions')
        self.retain_repo_versions = attributes[:'retain_repo_versions']
      end

      if attributes.key?(:'remote')
        self.remote = attributes[:'remote']
      end

      if attributes.key?(:'autopublish')
        self.autopublish = attributes[:'autopublish']
      else
        self.autopublish = false
      end

      if attributes.key?(:'metadata_signing_service')
        self.metadata_signing_service = attributes[:'metadata_signing_service']
      end

      if attributes.key?(:'package_signing_service')
        self.package_signing_service = attributes[:'package_signing_service']
      end

      if attributes.key?(:'package_signing_fingerprint')
        self.package_signing_fingerprint = attributes[:'package_signing_fingerprint']
      else
        self.package_signing_fingerprint = ''
      end

      if attributes.key?(:'retain_package_versions')
        self.retain_package_versions = attributes[:'retain_package_versions']
      end

      if attributes.key?(:'checksum_type')
        self.checksum_type = attributes[:'checksum_type']
      end

      if attributes.key?(:'metadata_checksum_type')
        self.metadata_checksum_type = attributes[:'metadata_checksum_type']
      end

      if attributes.key?(:'package_checksum_type')
        self.package_checksum_type = attributes[:'package_checksum_type']
      end

      if attributes.key?(:'gpgcheck')
        self.gpgcheck = attributes[:'gpgcheck']
      end

      if attributes.key?(:'repo_gpgcheck')
        self.repo_gpgcheck = attributes[:'repo_gpgcheck']
      end

      if attributes.key?(:'sqlite_metadata')
        self.sqlite_metadata = attributes[:'sqlite_metadata']
      else
        self.sqlite_metadata = false
      end

      if attributes.key?(:'repo_config')
        self.repo_config = attributes[:'repo_config']
      end

      if attributes.key?(:'compression_type')
        self.compression_type = attributes[:'compression_type']
      end

      if attributes.key?(:'layout')
        self.layout = attributes[:'layout']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      warn '[DEPRECATED] the `list_invalid_properties` method is obsolete'
      invalid_properties = Array.new
      if @name.nil?
        invalid_properties.push('invalid value for "name", name cannot be nil.')
      end

      if !@retain_repo_versions.nil? && @retain_repo_versions < 1
        invalid_properties.push('invalid value for "retain_repo_versions", must be greater than or equal to 1.')
      end

      if !@package_signing_fingerprint.nil? && @package_signing_fingerprint.to_s.length > 40
        invalid_properties.push('invalid value for "package_signing_fingerprint", the character length must be smaller than or equal to 40.')
      end

      if !@retain_package_versions.nil? && @retain_package_versions < 0
        invalid_properties.push('invalid value for "retain_package_versions", must be greater than or equal to 0.')
      end

      if !@gpgcheck.nil? && @gpgcheck > 1
        invalid_properties.push('invalid value for "gpgcheck", must be smaller than or equal to 1.')
      end

      if !@gpgcheck.nil? && @gpgcheck < 0
        invalid_properties.push('invalid value for "gpgcheck", must be greater than or equal to 0.')
      end

      if !@repo_gpgcheck.nil? && @repo_gpgcheck > 1
        invalid_properties.push('invalid value for "repo_gpgcheck", must be smaller than or equal to 1.')
      end

      if !@repo_gpgcheck.nil? && @repo_gpgcheck < 0
        invalid_properties.push('invalid value for "repo_gpgcheck", must be greater than or equal to 0.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      warn '[DEPRECATED] the `valid?` method is obsolete'
      return false if @name.nil?
      return false if !@retain_repo_versions.nil? && @retain_repo_versions < 1
      return false if !@package_signing_fingerprint.nil? && @package_signing_fingerprint.to_s.length > 40
      return false if !@retain_package_versions.nil? && @retain_package_versions < 0
      return false if !@gpgcheck.nil? && @gpgcheck > 1
      return false if !@gpgcheck.nil? && @gpgcheck < 0
      return false if !@repo_gpgcheck.nil? && @repo_gpgcheck > 1
      return false if !@repo_gpgcheck.nil? && @repo_gpgcheck < 0
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] retain_repo_versions Value to be assigned
    def retain_repo_versions=(retain_repo_versions)
      if !retain_repo_versions.nil? && retain_repo_versions < 1
        fail ArgumentError, 'invalid value for "retain_repo_versions", must be greater than or equal to 1.'
      end

      @retain_repo_versions = retain_repo_versions
    end

    # Custom attribute writer method with validation
    # @param [Object] package_signing_fingerprint Value to be assigned
    def package_signing_fingerprint=(package_signing_fingerprint)
      if package_signing_fingerprint.nil?
        fail ArgumentError, 'package_signing_fingerprint cannot be nil'
      end

      if package_signing_fingerprint.to_s.length > 40
        fail ArgumentError, 'invalid value for "package_signing_fingerprint", the character length must be smaller than or equal to 40.'
      end

      @package_signing_fingerprint = package_signing_fingerprint
    end

    # Custom attribute writer method with validation
    # @param [Object] retain_package_versions Value to be assigned
    def retain_package_versions=(retain_package_versions)
      if retain_package_versions.nil?
        fail ArgumentError, 'retain_package_versions cannot be nil'
      end

      if retain_package_versions < 0
        fail ArgumentError, 'invalid value for "retain_package_versions", must be greater than or equal to 0.'
      end

      @retain_package_versions = retain_package_versions
    end

    # Custom attribute writer method with validation
    # @param [Object] gpgcheck Value to be assigned
    def gpgcheck=(gpgcheck)
      if !gpgcheck.nil? && gpgcheck > 1
        fail ArgumentError, 'invalid value for "gpgcheck", must be smaller than or equal to 1.'
      end

      if !gpgcheck.nil? && gpgcheck < 0
        fail ArgumentError, 'invalid value for "gpgcheck", must be greater than or equal to 0.'
      end

      @gpgcheck = gpgcheck
    end

    # Custom attribute writer method with validation
    # @param [Object] repo_gpgcheck Value to be assigned
    def repo_gpgcheck=(repo_gpgcheck)
      if !repo_gpgcheck.nil? && repo_gpgcheck > 1
        fail ArgumentError, 'invalid value for "repo_gpgcheck", must be smaller than or equal to 1.'
      end

      if !repo_gpgcheck.nil? && repo_gpgcheck < 0
        fail ArgumentError, 'invalid value for "repo_gpgcheck", must be greater than or equal to 0.'
      end

      @repo_gpgcheck = repo_gpgcheck
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          pulp_href == o.pulp_href &&
          prn == o.prn &&
          pulp_created == o.pulp_created &&
          pulp_last_updated == o.pulp_last_updated &&
          versions_href == o.versions_href &&
          pulp_labels == o.pulp_labels &&
          latest_version_href == o.latest_version_href &&
          name == o.name &&
          description == o.description &&
          retain_repo_versions == o.retain_repo_versions &&
          remote == o.remote &&
          autopublish == o.autopublish &&
          metadata_signing_service == o.metadata_signing_service &&
          package_signing_service == o.package_signing_service &&
          package_signing_fingerprint == o.package_signing_fingerprint &&
          retain_package_versions == o.retain_package_versions &&
          checksum_type == o.checksum_type &&
          metadata_checksum_type == o.metadata_checksum_type &&
          package_checksum_type == o.package_checksum_type &&
          gpgcheck == o.gpgcheck &&
          repo_gpgcheck == o.repo_gpgcheck &&
          sqlite_metadata == o.sqlite_metadata &&
          repo_config == o.repo_config &&
          compression_type == o.compression_type &&
          layout == o.layout
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [pulp_href, prn, pulp_created, pulp_last_updated, versions_href, pulp_labels, latest_version_href, name, description, retain_repo_versions, remote, autopublish, metadata_signing_service, package_signing_service, package_signing_fingerprint, retain_package_versions, checksum_type, metadata_checksum_type, package_checksum_type, gpgcheck, repo_gpgcheck, sqlite_metadata, repo_config, compression_type, layout].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      attributes = attributes.transform_keys(&:to_sym)
      transformed_hash = {}
      openapi_types.each_pair do |key, type|
        if attributes.key?(attribute_map[key]) && attributes[attribute_map[key]].nil?
          transformed_hash["#{key}"] = nil
        elsif type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[attribute_map[key]].is_a?(Array)
            transformed_hash["#{key}"] = attributes[attribute_map[key]].map { |v| _deserialize($1, v) }
          end
        elsif !attributes[attribute_map[key]].nil?
          transformed_hash["#{key}"] = _deserialize(type, attributes[attribute_map[key]])
        end
      end
      new(transformed_hash)
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def self._deserialize(type, value)
      case type.to_sym
      when :Time
        Time.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        # models (e.g. Pet) or oneOf
        klass = PulpRpmClient.const_get(type)
        klass.respond_to?(:openapi_any_of) || klass.respond_to?(:openapi_one_of) ? klass.build(value) : klass.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
