=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
Generator version: 7.10.0

=end

require 'date'
require 'time'

module PulpRpmClient
  # A Serializer for UpdateRecord.
  class RpmUpdateRecordResponse
    attr_accessor :pulp_href

    # The Pulp Resource Name (PRN).
    attr_accessor :prn

    # Timestamp of creation.
    attr_accessor :pulp_created

    # Timestamp of the last time this resource was updated. Note: for immutable resources - like content, repository versions, and publication - pulp_created and pulp_last_updated dates will be the same.
    attr_accessor :pulp_last_updated

    # A dictionary of arbitrary key/value pairs used to describe a specific Content instance.
    attr_accessor :pulp_labels

    # Update id (short update name, e.g. RHEA-2013:1777)
    attr_accessor :id

    # Date when the update was updated (e.g. '2013-12-02 00:00:00')
    attr_accessor :updated_date

    # Update description
    attr_accessor :description

    # Date when the update was issued (e.g. '2013-12-02 00:00:00')
    attr_accessor :issued_date

    # Source of the update (e.g. security@redhat.com)
    attr_accessor :fromstr

    # Update status ('final', ...)
    attr_accessor :status

    # Update name
    attr_accessor :title

    # Short summary
    attr_accessor :summary

    # Update version (probably always an integer number)
    attr_accessor :version

    # Update type ('enhancement', 'bugfix', ...)
    attr_accessor :type

    # Severity
    attr_accessor :severity

    # Solution
    attr_accessor :solution

    # Update release
    attr_accessor :release

    # Copyrights
    attr_accessor :rights

    # Push count
    attr_accessor :pushcount

    # List of packages
    attr_accessor :pkglist

    # List of references
    attr_accessor :references

    # Reboot suggested
    attr_accessor :reboot_suggested

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'pulp_href' => :'pulp_href',
        :'prn' => :'prn',
        :'pulp_created' => :'pulp_created',
        :'pulp_last_updated' => :'pulp_last_updated',
        :'pulp_labels' => :'pulp_labels',
        :'id' => :'id',
        :'updated_date' => :'updated_date',
        :'description' => :'description',
        :'issued_date' => :'issued_date',
        :'fromstr' => :'fromstr',
        :'status' => :'status',
        :'title' => :'title',
        :'summary' => :'summary',
        :'version' => :'version',
        :'type' => :'type',
        :'severity' => :'severity',
        :'solution' => :'solution',
        :'release' => :'release',
        :'rights' => :'rights',
        :'pushcount' => :'pushcount',
        :'pkglist' => :'pkglist',
        :'references' => :'references',
        :'reboot_suggested' => :'reboot_suggested'
      }
    end

    # Returns all the JSON keys this model knows about
    def self.acceptable_attributes
      attribute_map.values
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'pulp_href' => :'String',
        :'prn' => :'String',
        :'pulp_created' => :'Time',
        :'pulp_last_updated' => :'Time',
        :'pulp_labels' => :'Hash<String, String>',
        :'id' => :'String',
        :'updated_date' => :'String',
        :'description' => :'String',
        :'issued_date' => :'String',
        :'fromstr' => :'String',
        :'status' => :'String',
        :'title' => :'String',
        :'summary' => :'String',
        :'version' => :'String',
        :'type' => :'String',
        :'severity' => :'String',
        :'solution' => :'String',
        :'release' => :'String',
        :'rights' => :'String',
        :'pushcount' => :'String',
        :'pkglist' => :'Array<RpmUpdateCollectionResponse>',
        :'references' => :'Array<Object>',
        :'reboot_suggested' => :'Boolean'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `PulpRpmClient::RpmUpdateRecordResponse` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `PulpRpmClient::RpmUpdateRecordResponse`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'pulp_href')
        self.pulp_href = attributes[:'pulp_href']
      end

      if attributes.key?(:'prn')
        self.prn = attributes[:'prn']
      end

      if attributes.key?(:'pulp_created')
        self.pulp_created = attributes[:'pulp_created']
      end

      if attributes.key?(:'pulp_last_updated')
        self.pulp_last_updated = attributes[:'pulp_last_updated']
      end

      if attributes.key?(:'pulp_labels')
        if (value = attributes[:'pulp_labels']).is_a?(Hash)
          self.pulp_labels = value
        end
      end

      if attributes.key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.key?(:'updated_date')
        self.updated_date = attributes[:'updated_date']
      end

      if attributes.key?(:'description')
        self.description = attributes[:'description']
      end

      if attributes.key?(:'issued_date')
        self.issued_date = attributes[:'issued_date']
      end

      if attributes.key?(:'fromstr')
        self.fromstr = attributes[:'fromstr']
      end

      if attributes.key?(:'status')
        self.status = attributes[:'status']
      end

      if attributes.key?(:'title')
        self.title = attributes[:'title']
      end

      if attributes.key?(:'summary')
        self.summary = attributes[:'summary']
      end

      if attributes.key?(:'version')
        self.version = attributes[:'version']
      end

      if attributes.key?(:'type')
        self.type = attributes[:'type']
      end

      if attributes.key?(:'severity')
        self.severity = attributes[:'severity']
      end

      if attributes.key?(:'solution')
        self.solution = attributes[:'solution']
      end

      if attributes.key?(:'release')
        self.release = attributes[:'release']
      end

      if attributes.key?(:'rights')
        self.rights = attributes[:'rights']
      end

      if attributes.key?(:'pushcount')
        self.pushcount = attributes[:'pushcount']
      end

      if attributes.key?(:'pkglist')
        if (value = attributes[:'pkglist']).is_a?(Array)
          self.pkglist = value
        end
      end

      if attributes.key?(:'references')
        if (value = attributes[:'references']).is_a?(Array)
          self.references = value
        end
      end

      if attributes.key?(:'reboot_suggested')
        self.reboot_suggested = attributes[:'reboot_suggested']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      warn '[DEPRECATED] the `list_invalid_properties` method is obsolete'
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      warn '[DEPRECATED] the `valid?` method is obsolete'
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          pulp_href == o.pulp_href &&
          prn == o.prn &&
          pulp_created == o.pulp_created &&
          pulp_last_updated == o.pulp_last_updated &&
          pulp_labels == o.pulp_labels &&
          id == o.id &&
          updated_date == o.updated_date &&
          description == o.description &&
          issued_date == o.issued_date &&
          fromstr == o.fromstr &&
          status == o.status &&
          title == o.title &&
          summary == o.summary &&
          version == o.version &&
          type == o.type &&
          severity == o.severity &&
          solution == o.solution &&
          release == o.release &&
          rights == o.rights &&
          pushcount == o.pushcount &&
          pkglist == o.pkglist &&
          references == o.references &&
          reboot_suggested == o.reboot_suggested
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [pulp_href, prn, pulp_created, pulp_last_updated, pulp_labels, id, updated_date, description, issued_date, fromstr, status, title, summary, version, type, severity, solution, release, rights, pushcount, pkglist, references, reboot_suggested].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      attributes = attributes.transform_keys(&:to_sym)
      transformed_hash = {}
      openapi_types.each_pair do |key, type|
        if attributes.key?(attribute_map[key]) && attributes[attribute_map[key]].nil?
          transformed_hash["#{key}"] = nil
        elsif type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[attribute_map[key]].is_a?(Array)
            transformed_hash["#{key}"] = attributes[attribute_map[key]].map { |v| _deserialize($1, v) }
          end
        elsif !attributes[attribute_map[key]].nil?
          transformed_hash["#{key}"] = _deserialize(type, attributes[attribute_map[key]])
        end
      end
      new(transformed_hash)
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def self._deserialize(type, value)
      case type.to_sym
      when :Time
        Time.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        # models (e.g. Pet) or oneOf
        klass = PulpRpmClient.const_get(type)
        klass.respond_to?(:openapi_any_of) || klass.respond_to?(:openapi_one_of) ? klass.build(value) : klass.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
