=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
Generator version: 7.10.0

=end

require 'date'
require 'time'

module PulpRpmClient
  # Variant serializer.
  class VariantResponse
    # Variant id.
    attr_accessor :variant_id

    # Variant uid.
    attr_accessor :uid

    # Variant name.
    attr_accessor :name

    # Variant type.
    attr_accessor :type

    # Relative path to directory with binary RPMs.
    attr_accessor :packages

    # Relative path to directory with source RPMs.
    attr_accessor :source_packages

    # Relative path to YUM repository with source RPMs.
    attr_accessor :source_repository

    # Relative path to directory with debug RPMs.
    attr_accessor :debug_packages

    # Relative path to YUM repository with debug RPMs.
    attr_accessor :debug_repository

    # Relative path to a pem file that identifies a product.
    attr_accessor :identity

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'variant_id' => :'variant_id',
        :'uid' => :'uid',
        :'name' => :'name',
        :'type' => :'type',
        :'packages' => :'packages',
        :'source_packages' => :'source_packages',
        :'source_repository' => :'source_repository',
        :'debug_packages' => :'debug_packages',
        :'debug_repository' => :'debug_repository',
        :'identity' => :'identity'
      }
    end

    # Returns all the JSON keys this model knows about
    def self.acceptable_attributes
      attribute_map.values
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'variant_id' => :'String',
        :'uid' => :'String',
        :'name' => :'String',
        :'type' => :'String',
        :'packages' => :'String',
        :'source_packages' => :'String',
        :'source_repository' => :'String',
        :'debug_packages' => :'String',
        :'debug_repository' => :'String',
        :'identity' => :'String'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
        :'source_packages',
        :'source_repository',
        :'debug_packages',
        :'debug_repository',
        :'identity'
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `PulpRpmClient::VariantResponse` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `PulpRpmClient::VariantResponse`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'variant_id')
        self.variant_id = attributes[:'variant_id']
      else
        self.variant_id = nil
      end

      if attributes.key?(:'uid')
        self.uid = attributes[:'uid']
      else
        self.uid = nil
      end

      if attributes.key?(:'name')
        self.name = attributes[:'name']
      else
        self.name = nil
      end

      if attributes.key?(:'type')
        self.type = attributes[:'type']
      else
        self.type = nil
      end

      if attributes.key?(:'packages')
        self.packages = attributes[:'packages']
      else
        self.packages = nil
      end

      if attributes.key?(:'source_packages')
        self.source_packages = attributes[:'source_packages']
      else
        self.source_packages = nil
      end

      if attributes.key?(:'source_repository')
        self.source_repository = attributes[:'source_repository']
      else
        self.source_repository = nil
      end

      if attributes.key?(:'debug_packages')
        self.debug_packages = attributes[:'debug_packages']
      else
        self.debug_packages = nil
      end

      if attributes.key?(:'debug_repository')
        self.debug_repository = attributes[:'debug_repository']
      else
        self.debug_repository = nil
      end

      if attributes.key?(:'identity')
        self.identity = attributes[:'identity']
      else
        self.identity = nil
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      warn '[DEPRECATED] the `list_invalid_properties` method is obsolete'
      invalid_properties = Array.new
      if @variant_id.nil?
        invalid_properties.push('invalid value for "variant_id", variant_id cannot be nil.')
      end

      if @uid.nil?
        invalid_properties.push('invalid value for "uid", uid cannot be nil.')
      end

      if @name.nil?
        invalid_properties.push('invalid value for "name", name cannot be nil.')
      end

      if @type.nil?
        invalid_properties.push('invalid value for "type", type cannot be nil.')
      end

      if @packages.nil?
        invalid_properties.push('invalid value for "packages", packages cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      warn '[DEPRECATED] the `valid?` method is obsolete'
      return false if @variant_id.nil?
      return false if @uid.nil?
      return false if @name.nil?
      return false if @type.nil?
      return false if @packages.nil?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          variant_id == o.variant_id &&
          uid == o.uid &&
          name == o.name &&
          type == o.type &&
          packages == o.packages &&
          source_packages == o.source_packages &&
          source_repository == o.source_repository &&
          debug_packages == o.debug_packages &&
          debug_repository == o.debug_repository &&
          identity == o.identity
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [variant_id, uid, name, type, packages, source_packages, source_repository, debug_packages, debug_repository, identity].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      attributes = attributes.transform_keys(&:to_sym)
      transformed_hash = {}
      openapi_types.each_pair do |key, type|
        if attributes.key?(attribute_map[key]) && attributes[attribute_map[key]].nil?
          transformed_hash["#{key}"] = nil
        elsif type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[attribute_map[key]].is_a?(Array)
            transformed_hash["#{key}"] = attributes[attribute_map[key]].map { |v| _deserialize($1, v) }
          end
        elsif !attributes[attribute_map[key]].nil?
          transformed_hash["#{key}"] = _deserialize(type, attributes[attribute_map[key]])
        end
      end
      new(transformed_hash)
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def self._deserialize(type, value)
      case type.to_sym
      when :Time
        Time.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        # models (e.g. Pet) or oneOf
        klass = PulpRpmClient.const_get(type)
        klass.respond_to?(:openapi_any_of) || klass.respond_to?(:openapi_one_of) ? klass.build(value) : klass.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
